-*- coding: utf-8 -*-

base-url = https://github.com/ruby/ruby

commit 8d764da35768073c2e21ffeffa27ff2f3ab589b0
  Author:     Chris Hasiński <krzysztof.hasinski@gmail.com>
  AuthorDate: 2026-01-08 09:13:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-09 02:08:38 +0900

    Fix incorrect bundled gems warning for hyphenated gem names

    When requiring a file like "benchmark/ips", the warning system would
    incorrectly warn about the "benchmark" gem not being a default gem,
    even when the user has "benchmark-ips" (a separate third-party gem)
    in their Gemfile.

    The fix checks if a hyphenated version of the require path exists in
    the bundle specs before issuing a warning. For example, requiring
    "benchmark/ips" now checks for both "benchmark" and "benchmark-ips"
    in the Gemfile.

    [Bug #21828]

commit be5d24eb0380360d0a1aeea99545d837ffe3eb24
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2026-01-06 06:47:53 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 06:47:53 +0900

    Add k0kubun as CODEOWNERS

commit e7b92abf3ab1a5f1eb6bae74df9ee71cd13a96dd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2026-01-06 06:33:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 06:42:15 +0900

    ruby-bench: Prefer --excludes over rm -rf

    to remind us of skipped benchmarks in the CI job names

commit 34aa97ed60a87cad9a4b016cf6393b83bc6b2797
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-26 10:14:16 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 06:41:58 +0900

    Disabled to run lobsters benchmark because it didn't work with Ruby 4.1 yet

commit d555ddcfb3ec3cce17ff78f1823a6c026a0d2b1e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-26 11:11:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 06:21:10 +0900

    uutils-coreutils 0.5.0 has been removed uutils wrapper

commit 9b2ff68f17d225aed2ae9e72a51014cbfcaaaff1
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-30 22:01:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 06:00:14 +0900

    Box: skip checking the current box is the root box

    Because checking the current box is not a cheap process.

commit b3371c6ae5dd6fcecd12128f7b3e1e18e219bd3d
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-30 14:46:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 06:00:14 +0900

    Box: allocate classes as boxable when it happens in the root box

    Without this change, classes (including iclass) are allocated
    as un-boxable classes after initializing user boxes (after starting
    script evaluation). Under this situation, iclasses are created as
    un-boxabled class when core modules are included by a class in the
    root box, then it causes problems because it's in the root box but
    it can't have multiple classexts.

    This change makes it possible to allocate boxable classes even after
    initializing user boxes. Classes create in the root box will be
    boxable, and those can have 2 or more classexts.

commit 35c140f92be2c0676c6433e037996926aa935982
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-26 17:14:57 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-26 21:23:56 +0900

    [DOC] Remove outdated documentation about command injection

    [Feature #19630]

    This dangerous behavior was removed in 4.0 (996cae65f3cc8fed60c6bb758b00882cac49389d)
    but the documentation wasn't updated.

commit 553f1675f3a9cece340b90f374a4245dccac2272
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2025-12-25 12:20:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2025-12-25 12:20:40 +0900

    v4.0.0

commit d375bcc965d4a0c661785fa94150f6202e99c1ce
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-25 11:56:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-25 11:56:41 +0900

    [DOC] Escape capitalized word "data" not to be linked unexpectedly

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15731

commit b908306f99db834470167d569b81661d7b19a02b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-25 11:45:27 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 11:49:32 +0900

    [DOC] Reword "Regular Expression" to "Matched Data"

    `$~` and its accessors are related to regular expressions, but are not
    themselves.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15730

commit 84edb8456e90ae79428bf5e5db3accf29cdc9999
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-25 11:47:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 11:47:08 +0900

    Revert "Rollback to minitest-5.27.0"

    This reverts commit 8d097bc472fc66221dee23bb8f9e0dddac16db23.

commit 3c4cda10eb80fa38f2b27d4774e3e3e82bf190c9
  Author:     Godfrey Chan <godfreykfc@gmail.com>
  AuthorDate: 2025-12-25 09:06:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-25 09:06:50 +0900

    [DOC] Add back Rust 1.85.0 requirement to NEWS.md (#15728)

    * [DOC] Add back Rust 1.85.0 requirement to NEWS.md

    Addresses k0kubun's review in https://github.com/ruby/ruby/pull/15711#issuecomment-3690541074

    NEWS.md serves both CRuby developers as well as end-users. As the
    release date closes in, it probably gets seen by more users than
    core developers (on the blog for example).

    Most users probably don't build Ruby by hand, and instead that is
    abstracted through tools like ruby-install or a package manager.
    For some users these tools may install pre-built binaries where
    they exist, in which case the Rust requirement doesn't apply. In
    other instances, the tools merely automate the build, in which case
    the correct rustc version is required to enable support.

    It is also a little confusing to talk about "enabling support for
    the JIT during the build" vs "enabling the JIT at runtime".

    This copy attempts to balance all of the above and hopefully gets
    the correct points across all intended audiences.

    * Apply suggestion from k0kubun

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

    ---------

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 3e82da723241b7205dc2b7706c66e9ead1826cde
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-25 07:37:25 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-25 07:37:25 +0900

    ZJIT: Don't mark control-flow opcodes as invalidating locals (#15694)

    jump, branchif, etc don't invalidate locals in the JIT; they might in the interpreter because they can execute arbitrary code, but the JIT side exits before that happens.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 8d097bc472fc66221dee23bb8f9e0dddac16db23
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-25 05:52:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 06:52:46 +0900

    Rollback to minitest-5.27.0

    Test of 6.0.0 is not working with 4.0.0 stable version.

    https://github.com/ruby/actions/actions/runs/20488398805/job/58875672023#step:20:362

    ```
      rake aborted!
      NoMethodError: undefined method 'cov_filter=' for #<Hoe:0x00007fdb550fc840> (NoMethodError)

        self.cov_filter = %w[ tmp ]
            ^^^^^^^^^^^^^
      /home/runner/work/actions/actions/ruby-4.0.0/gems/src/minitest/Rakefile:20:in 'block in <top (required)>'
      /home/runner/work/actions/actions/ruby-4.0.0/.bundle/gems/hoe-3.20.0/lib/hoe.rb:394:in 'BasicObject#instance_eval'
      /home/runner/work/actions/actions/ruby-4.0.0/.bundle/gems/hoe-3.20.0/lib/hoe.rb:394:in 'Hoe.spec'
      /home/runner/work/actions/actions/ruby-4.0.0/gems/src/minitest/Rakefile:11:in '<top (required)>'
      /home/runner/work/actions/actions/ruby-4.0.0/.bundle/gems/rake-13.3.1/exe/rake:27:in '<top (required)>'
      (See full trace by running task with --trace)
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15727

commit 26a1a522b76cc9fd2ed2d963fd2df635f59b7a39
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-25 05:47:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 05:47:34 +0900

    Revert "Rollback to test-unit 3.7.3"

    This reverts commit c17307ac22f37f74786a4f016121c6ee8cc38915.

commit 8caea03213ff809544271d3135e0873d9c419532
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-12-25 02:13:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 05:46:44 +0900

    rbs_skip_tests_windows

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15725

commit b92bc9654120547f9dd261ce04dacdb17bf720e1
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-12-25 01:41:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 05:46:44 +0900

    Skip test to avoid NoMemoryError

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15725

commit d0193e924003b33ab46ee4ac13fbec5d53d02f1b
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-12-25 01:40:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 05:46:44 +0900

    Bundle test-unit 3.7.5

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15725

commit 96d876534e115ffbb92a72f7378da84fd54a3a87
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2025-12-25 03:54:39 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-25 05:45:16 +0900

    Bump RDoc to 7.0.3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15726

commit 479f8682c80e695c2a1f8dd66c82cc530c5bbf40
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2025-12-24 23:39:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2025-12-24 23:52:45 +0900

    Remove extra help

commit 29ffc5d624f21d101d819bc77b7a048ab70d1c13
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2025-12-24 23:07:35 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2025-12-24 23:07:35 +0900

    Reapply "Extract `ruby_api_version_name`"

    This reverts commit ba2f6972193cdbd7c1e77e26212513e47926b115.

    Box already used ruby_api_version_name.

commit 285e22edc55522f3466357c4c27615a6015d84dc
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2025-12-24 22:52:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2025-12-24 22:55:44 +0900

    Revert "Add link to Ruby options doc in help text"

    This reverts commit 31ff07ed1eb05d01f7da3c017d542137a3db1e94.

    * Don't add a test which only runs on production release
      * https://github.com/ruby/actions/actions/runs/20486784889/job/58870959976
    * Don't add a new line to `ruby --help`
      * https://github.com/ruby/ruby/pull/14142#issuecomment-3689829564

commit ba2f6972193cdbd7c1e77e26212513e47926b115
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2025-12-24 22:47:02 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2025-12-24 22:55:44 +0900

    Revert "Extract `ruby_api_version_name`"

    This reverts commit 9b576cd6255aba97e5e2f55f4b09f00c7dd0e839.

commit 8de2622c1291afd29a9a570e6b396bbe722360a3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-20 21:37:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-24 22:11:58 +0900

    Fix a fragile test

    `Dir.mktmpdir` concatenates a random base-36 number separated by "-",
    so may generate pathnames containing "-j2".

commit f00abcfdc33f7bcbf4b30c947487ade8181e84f9
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-24 17:43:37 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-24 21:29:00 +0900

    Prevent "warning: assigned but unused variable - it"

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15719

commit 17e4f28c2725495a2ff14e1899d791868d9ba42f
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-24 17:43:22 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-24 21:29:00 +0900

    Remove unintentional return

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15719

commit 2d0d95305c0973c0a8966a07fa029c55e27f94cd
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-24 17:53:35 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-24 21:09:33 +0900

    ext/-test-/scheduler/scheduler.c: explicitly ignore the result of write

    ```
    scheduler.c:44:5: warning: ignoring return value of ‘write’ declared with attribute ‘warn_unused_result’ [-Wunused-result]
       44 |     write(blocking_state->notify_descriptor, "x", 1);
          |     ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15720

commit df1c9a06ac42871519a05d53fd6909567cc4531f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-24 16:42:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-24 19:49:07 +0900

    Win32: Remove an unused function

    Since 50e5c542cc0541fb38e52766d88d87bd8a96b072, `constat_reset` is no
    longer used.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15718

commit c17307ac22f37f74786a4f016121c6ee8cc38915
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 18:37:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 19:44:54 +0900

    Rollback to test-unit 3.7.3

    3.7.5 is not working with rbs-3.10.0

    https://github.com/ruby/ruby/actions/runs/20480628393/job/58853288287#step:22:353

    ```
      D:/a/ruby/ruby/src/.bundle/gems/test-unit-3.7.5/lib/test/unit/testcase.rb:641:in 'block (2 levels) in Test::Unit::TestCase#run': failed to allocate memory (NoMemoryError)
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15721

commit 6e20e92d0ad006e508842839eed77b9642051874
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 18:36:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 19:44:54 +0900

    Disable auto-update of bundled gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15721

commit aaed4ccc64467c77cd3670a309b39e4b283ff69f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 17:32:39 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 17:32:39 +0900

    Restore gem updates that are accidentally deleted

commit ca67e72bcd580e9216e3d73e4a06a4bae6f0bd09
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 17:26:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 17:26:10 +0900

    Added release histories of default/bundled gems from Ruby 3.4.8

commit 1c07158203f00d020841f2400002f6e9b62d1318
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 16:10:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 16:10:41 +0900

    Update to test-unit 3.7.5 at NEWS.md

commit 422ff2737050e4c2f8bf1b42f738f08d713df910
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 16:09:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 16:10:00 +0900

    Added https://github.com/ruby/net-http/issues/205 to NEWS.md

commit 04a646220148cad882b0a92665e617c6aca94bc2
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-24 15:55:30 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-24 15:55:30 +0900

    Update bundled gems list as of 2025-12-24

commit 88d6c5aaa82105d96c37847723bcf0151deb6497
  Author:     Godfrey Chan <godfreykfc@gmail.com>
  AuthorDate: 2025-12-24 15:43:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-24 15:43:40 +0900

    [DOC] Update ZJIT status in NEWS.md

    As for Ruby v4.0.0-preview3, ZJIT support is enabled by default on
    supported platforms. The previous phrasing is not relevant for most
    users. Replaced with brief instructions for enabling the JIT itself.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15711

    Merged-By: nobu <nobu@ruby-lang.org>

commit f7b48456ebffa1dfe7fe201b27c9c34b5703a53e
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-23 22:27:06 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-24 15:10:25 +0900

    Box: show the fully qualified URL of the Ruby::Box doc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15704

commit 352de161ff9765bbb68a2ec015f2c02b5b0b534b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-24 11:04:23 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-24 14:41:02 +0900

    Remove an extra dot from `RUBY_API_VERSION_STR`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15713

commit fc19ce0a0187a8d69df88a1231ec93b0e3e990b2
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2025-12-24 11:14:44 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2025-12-24 14:10:51 +0900

    Lrama v0.7.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15717

commit 44693ee32990fdd609e91ebb2970b3110b3f08e5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-24 11:30:11 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-24 14:05:41 +0900

    Fix a possible memory leak in dtoa

    Fix GH-15061

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15714

commit 6af9b8d59af176183c15589afc64505f5ada692c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 13:59:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 13:59:08 +0900

    Minor update at stdlib section

commit 7d2815d907e6dc7ce0075a8dd1a4e45b8e647921
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 13:48:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 13:48:35 +0900

    Add flag for prevent to update NEWS.md for release day.

commit 342d25785c0332ba556da2bae960d2a4f4b8baad
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-24 12:11:38 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-24 12:30:54 +0900

    [DOC] Fix backticks in Coverage.peek_result

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15716

commit 202028aea170e43609f5061548578a1b5681414b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-24 11:56:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 12:24:50 +0900

    Update the latest results of test-bundled-gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15715

commit ab683d56bc625c83d815741b3bfd9c606b14517f
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-24 11:46:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-24 11:46:57 +0900

    [DOC] Cross-links between Japanese and English pages (#15705)

    * [DOC] Cross-links between Japanese and English pages

  Notes:
    Merged-By: BurdetteLamar <BurdetteLamar@Yahoo.com>

commit 9154d72a3e342b6bf101d0d1e3c8bbd0feee3422
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2025-12-24 05:17:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 11:21:11 +0900

    Improve CGI.escape* docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15709

commit 10a68210b4c96ab2de21357907627e1fb34ce000
  Author:     TOMITA Masahiro <tommy@tmtm.org>
  AuthorDate: 2025-11-06 09:09:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 11:14:29 +0900

    [DOC] Fix IO::Buffer document

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15071

commit 6e2bf5df4eeab8e37fab86206d4f2e8ab36a60b7
  Author:     aguspe <agustin.pe94@gmail.com>
  AuthorDate: 2025-12-24 02:07:15 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-24 11:03:20 +0900

    [Tests] Assert Module#set_temporary_name returns self

    The return value of Module#set_temporary_name was changed
    to return `self`, but the existing tests
    did not verify this.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15706

commit ceea8060e4cc94846b2ff32fe8b0bb39049eda2e
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-10-03 22:04:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 10:59:56 +0900

    Properly handle test cases terminated by signals in test-bundled-gems

    Process::Status#exitstatus turn into nil when child process is signeled.
    When exit_code was unchanged, test-bundled-gems.rb returned 0 and make was unable to detect the failure. Fix this.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/14716

commit 688c1f6c5e96dfa3e4f6b16c617545ded7c8c0b4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 15:22:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 10:46:58 +0900

    [DOC] Reword "Pattern Matching" to "Regular Expression"

    In ruby, since 3.1 at least, the words "Pattern Matching" should refer
    the syntax.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15417

commit e2a58c45b1c79204ae80b3960f44a818ec00b94e
  Author:     Steve <savio@kwara.com>
  AuthorDate: 2025-12-21 20:49:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-24 10:39:49 +0900

    [DOC] Fix minor typo in signals.rdoc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15682

commit 30d9782c5c07db2d5df44656eb0218616f7b0bb5
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-12-24 09:26:07 +0900
  Commit:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  CommitDate: 2025-12-24 10:10:09 +0900

    Tidy up fiber scheduler tests.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15712

commit 2df72c0c1a686052ab00f853bb15bd67dcbfedd4
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-12-24 09:09:05 +0900
  Commit:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  CommitDate: 2025-12-24 10:10:09 +0900

    Fix flaky test.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15712

commit 01d1cbbbec3d40cb2e3f564371beb9dc3729c7ba
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2025-12-24 09:53:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-24 09:53:08 +0900

    [DOC] Enhance Fiber::Scheduler docs (#15708)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit e2cf92eddc5403316b0d449b02ba403a27610d7b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-24 02:59:41 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-24 03:54:08 +0900

    Move special const check to gc.c for rb_gc_impl_object_moved_p

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15707

commit d7d11090991d217b1eeb36d5dce5102bdba8b277
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2025-12-24 02:09:41 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-24 02:09:41 +0900

    Describe base code layout rules (#15696)

    * Describe base code layout rules

    * Enhance optional keyword explanation

    * Change the logical operators description

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit d517e04806616d2384fd2e1e3aa63eea99036669
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-23 01:51:04 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-23 23:00:04 +0900

    [DOC] Combine docs for Method#call aliases

    RDoc does not parse the documentation for the Method#call aliases, so we
    should combine the aliases into one documentation.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15693

commit ab565a3e0de7c6e75b31a32d60a0a6f77ff4122f
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-23 19:41:56 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-23 21:51:59 +0900

    Box: split the test for CI timeouts

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15703

commit 515119541095bcb84cb8d85db644d836eeeeef33
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-20 21:37:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-23 18:53:36 +0900

    Fix a fragile test

    `Dir.mktmpdir` concatenates a random base-36 number separated by "-",
    so may generate pathnames containing "-j4".

commit 3ddf69500ffd76efd28e45d2e101a85fca0d8a61
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-23 17:52:15 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-23 17:52:15 +0900

    Update bundled gems list as of 2025-12-23

commit 2ed9a7bde26a06cf5eff38e01702af80251d29b3
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-12-23 17:51:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-23 17:51:32 +0900

    Bundle RBS 3.10.0 (#15701)

    * Bundle RBS 3.10.0
    * Unskip BigDecimal tests

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit d879f9f69691778c6c9ffe4b084172a4546bb46b
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-12-22 15:58:08 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-23 17:02:25 +0900

    [DOC] Fix example in Ruby::Box documentation

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15690

commit b04e61c3909a5fa63e1235c03d160ed778cae086
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-23 16:30:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-23 16:30:58 +0900

    Added release note for RubyGems 4.0.3

commit 1c3ef2719155b56f14bf734c82b26ef0bbaac798
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-23 13:48:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-23 16:10:04 +0900

    Merge RubyGems 4.0.3 and Bundler 4.0.3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15700

commit 8eaf6739fda591233b07f3ada7ed4e87845347b9
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-23 13:00:33 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-23 13:03:02 +0900

    [ruby/error_highlight] Bump version

    https://github.com/ruby/error_highlight/commit/dc2dad6632

commit 0b3199a65333a0ea8a3a653b3151674602ad4e84
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-23 09:08:21 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-23 09:12:38 +0900

    [DOC] Fix backticks in docs for Set#add

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15698

commit e69f41a0a88df1d843f5d94cc4e5e757b96300e0
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-23 07:52:52 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-23 07:52:52 +0900

    [DOC] Languages in Examples (#15697)

    * [DOC] Languages in Examples

    * Update doc/contributing/documentation_guide.md

    Co-authored-by: Jeremy Evans <code@jeremyevans.net>

    * Update doc/contributing/documentation_guide.md

    Co-authored-by: Jeremy Evans <code@jeremyevans.net>

    ---------

    Co-authored-by: Jeremy Evans <code@jeremyevans.net>

  Notes:
    Merged-By: BurdetteLamar <BurdetteLamar@Yahoo.com>

commit af30e4714ccb0dabff85298ee2305d84103b98d1
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-23 01:24:08 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-23 06:54:27 +0900

    [ruby/mmtk] Implement Ruby heap

    This heap emulates the growth characteristics of the Ruby default GC's
    heap. By default, the heap grows by 40%, requires at least 20% empty
    after a GC, and allows at most 65% empty before it shrinks the heap. This
    is all configurable via the same environment variables the default GC
    uses (`RUBY_GC_HEAP_FREE_SLOTS_GOAL_RATIO`, `RUBY_GC_HEAP_FREE_SLOTS_MIN_RATIO`,
    `RUBY_GC_HEAP_FREE_SLOTS_MAX_RATIO`, respectively).

    The Ruby heap can be enabled via the `MMTK_HEAP_MODE=ruby` environment
    variable.

    Compared to the dynamic heap in MMTk (which uses the MemBalancer algorithm),
    the Ruby heap allows the heap to grow more generously, which uses a bit
    more memory but offers significant performance gains because it runs GC
    much less frequently.

    We can see in the benchmarks below that this Ruby heap heap gives faster
    performance than the dynamic heap in every benchmark, with over 2x faster
    in many of them. We see that memory is often around 10-20% higher with
    certain outliers that use significantly more memory like hexapdf and
    erubi-rails. We can also see that this brings MMTk's Ruby heap much
    closer in performance to the default GC.

    Ruby heap benchmark results:

        --------------  --------------  ----------  ---------
        bench           ruby heap (ms)  stddev (%)  RSS (MiB)
        activerecord    233.6           10.7        85.9
        chunky-png      457.1           1.1         79.3
        erubi-rails     1148.0          3.8         133.3
        hexapdf         1570.5          2.4         403.0
        liquid-c        42.8            5.3         43.4
        liquid-compile  41.3            7.6         52.6
        liquid-render   102.8           3.8         55.3
        lobsters        651.9           8.0         426.3
        mail            106.4           1.8         67.2
        psych-load      1552.1          0.8         43.4
        railsbench      1707.2          6.0         145.6
        rubocop         127.2           15.3        148.8
        ruby-lsp        136.6           11.7        113.7
        sequel          47.2            5.9         44.4
        shipit          1197.5          3.6         301.0
        --------------  --------------  ----------  ---------

    Dynamic heap benchmark results:

        --------------  -----------------  ----------  ---------
        bench           dynamic heap (ms)  stddev (%)  RSS (MiB)
        activerecord    845.3              3.1         76.7
        chunky-png      525.9              0.4         38.9
        erubi-rails     2694.9             3.4         115.8
        hexapdf         2344.8             5.6         164.9
        liquid-c        73.7               5.0         40.5
        liquid-compile  107.1              6.8         40.3
        liquid-render   147.2              1.7         39.5
        lobsters        697.6              4.5         342.0
        mail            224.6              2.1         64.0
        psych-load      4326.7             0.6         37.4
        railsbench      3218.0             5.5         124.7
        rubocop         203.6              6.1         110.9
        ruby-lsp        350.7              3.2         79.0
        sequel          121.8              2.5         39.6
        shipit          1510.1             3.1         220.8
        --------------  -----------------  ----------  ---------

    Default GC benchmark results:

        --------------  ---------------  ----------  ---------
        bench           default GC (ms)  stddev (%)  RSS (MiB)
        activerecord    148.4            0.6         67.9
        chunky-png      440.2            0.7         57.0
        erubi-rails     722.7            0.3         97.8
        hexapdf         1466.2           1.7         254.3
        liquid-c        32.5             3.6         42.3
        liquid-compile  31.2             1.9         35.4
        liquid-render   88.3             0.7         30.8
        lobsters        633.6            7.0         305.4
        mail            76.6             1.6         53.2
        psych-load      1166.2           1.3         29.1
        railsbench      1262.9           2.3         114.7
        rubocop         105.6            0.8         95.4
        ruby-lsp        101.6            1.4         75.4
        sequel          27.4             1.2         33.1
        shipit          1083.1           1.5         163.4
        --------------  ---------------  ----------  ---------

    https://github.com/ruby/mmtk/commit/c0ca29922d

commit 481f16f3f1298c8962bdbc97f6c1eff9df90002a
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-23 03:22:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-23 03:22:01 +0900

    [DOC] Improve ractor class docs (grammar, code examples) (#15686)

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 6a2cd630d5d4188f2d6d94a136821af72774e7ba
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-19 08:23:30 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-22 23:12:54 +0900

    [DOC] Improve call-seq of Proc#call

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15637

commit f98bbb74740d80ad865fe294f8c8035ec0a9bb10
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-22 23:12:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-22 23:12:33 +0900

    [DOC] Doc for Rational#<=>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15684

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 5272f2bc95770bf483795532ac807884f8932c23
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2025-12-22 21:00:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-22 21:00:09 +0900

    Bump RDoc to 7.0.2 (#15691)

  Notes:
    Merged-By: st0012 <stan001212@gmail.com>

commit 2191768980f61a0610acf4cfef558d5c6635e3c8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-22 14:58:51 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-22 14:58:51 +0900

    [DOC] Refine packed_data.rdoc

    * Escape unexpected links
    * Remove unnecessary path name from in-file reference

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15689

commit 87e78e6f8a7cf88bd3f8d3df2fbcfdb9c53a5294
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-22 14:39:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-22 14:39:41 +0900

    [DOC] Add multiline condition code example that was already possible

    To avoid the misconception that previously conditional code had to be
    written on a single line.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15688

commit cfb324e9d12d0d40a8f9052b97a860737b78224f
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 11:38:25 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-22 04:08:00 +0900

    [DOC] Improve docs for Method#>>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15663

commit 9f8231b7f8a7c625bbfdbfa0bfb838cd0ab1d941
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 10:48:05 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-22 04:08:00 +0900

    [DOC] Update call-seq for Method#>>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15663

commit 759187b56043c3cda2887e3445f19a35d55743cb
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 10:45:58 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-22 04:08:00 +0900

    [DOC] Improve docs for Method#<<

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15663

commit 76441060f230b8a797c1792e71dcce308ca3cf43
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 10:38:34 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-22 04:08:00 +0900

    [DOC] Update call-seq for Method#<<

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15663

commit ab4a0b4e0ec30fe7567fe6c9ef04d8ff851f256f
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-22 00:40:24 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-22 04:05:55 +0900

    [DOC] Doc for File::Stat<=>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15683

commit 2d69facd2093ed9e51a6e10f8234c4fda07ef6f1
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-22 04:05:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-22 04:05:38 +0900

    [DOC] Tweaks for Object#<=>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15678

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit d0ec60dc7bd6dc6fb87b3949e3cb8127f6b9cc86
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-22 03:26:10 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-22 03:26:10 +0900

    More doc improvements to ractor.md (#15676)

    [DOC] More doc improvements to ractor.md

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 37b98f0df71e85a831677562dc08f6ce6cdae842
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-21 01:42:36 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 22:59:28 +0900

    [ruby/mmtk] Add a 32 byte heap for allocating smaller objects

    https://github.com/ruby/mmtk/commit/c4cca6c1c3

commit d8b33993e1ba1fc948db435f363e165e89badccc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-21 20:31:30 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-21 20:31:30 +0900

    Box: Fix an unused variable warning

commit 2ffd5ad05f0df2b33540f8fad4220aecbceab98e
  Author:     kitazawa <3143443+krororo@users.noreply.github.com>
  AuthorDate: 2025-12-21 18:35:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-21 18:35:32 +0900

    [DOC] Remove duplicate Pathname promotion entry at NEWS.md

    The Pathname promotion to core class is already documented in the
    "Core classes updates" section, making this duplicate entry
    redundant.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15681

    Merged-By: nobu <nobu@ruby-lang.org>

commit 038b158fa30d1b1cda153aeb10dac5f59f966036
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-21 06:08:01 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 11:55:12 +0900

    [ruby/mmtk] Implement fast path for bump pointer allocator

    Adding a fast path for bump pointer allocator can improve allocation
    performance.

    For the following microbenchmark with MMTK_HEAP_MIN=100MiB:

        10_000_000.times { String.new }

    Before:

        810.7 ms ±   8.3 ms    [User: 790.9 ms, System: 40.3 ms]

    After:

        777.9 ms ±  10.4 ms    [User: 759.0 ms, System: 37.9 ms]

    https://github.com/ruby/mmtk/commit/0ff5c9f579

commit 1bc2a9158966a4a1556529d8bb50fae66fa11bb0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-21 11:31:36 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-21 11:31:36 +0900

    [DOC] Align tables in globals.md

    * Align "Contains" column in "Streams" table
    * Align some columns vertically
    * Remove a duplicate `$-a` description

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15680

commit e2243ed232d6a67e4a3e84e30e82b792a39b21e0
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-21 09:32:30 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 11:24:37 +0900

    [DOC] Correct typo

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15679

commit 483ef3a0d2a6c097ca1606c5cb4a0fae8f3d4f43
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-21 07:01:05 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 08:14:48 +0900

    Test test_remove_instance_variable_re_embed separately

    Shape tree pollution could cause this test to flake.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15672

commit f42535fa38ff487382db32158908635e1a356d5c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-21 06:33:21 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 08:14:48 +0900

    Change test to define ivars in initialize method

    Defining ivars in initialize method guarantees the object to be embedded.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15672

commit 580872785181303f26f715b5acc611d0ec087256
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-21 07:30:03 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 08:13:17 +0900

    [DOC] Fix indentation error in Complex#<=>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15675

commit addbeb6cf337695647db6e265b5db87105d1c2e9
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-21 07:22:35 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 08:13:08 +0900

    [DOC] Note for String#<=> about Comparable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15674

commit 7c1e37cfe13cf2df21e4ca23c91f5a53c81bc062
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-21 07:57:00 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 08:12:56 +0900

    [DOC] Tweaks for Module#<=>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15677

commit 3fee7dd90d19790950f476614ae53a95b7730592
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-21 05:28:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-21 05:28:04 +0900

    Small improvements to doc/language/ractor.md (#15588)

    [DOC] Improvements to doc/language/ractor.md

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 6d5605b28a800be19357ec57ff6c8e1118aabca0
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-21 01:39:58 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 01:41:11 +0900

    [ruby/mmtk] Make rb_gc_impl_heap_id_for_size use MMTK_HEAP_COUNT

    https://github.com/ruby/mmtk/commit/2185189df4

commit fe9a7448b131a48ee37df720fbbfae3142d274ca
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 22:40:59 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-21 01:27:34 +0900

    Check slot_size before zeroing memory for GC hook

    If the slot_size < RVALUE_SIZE then we would underflow in the memset.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15669

commit 5cdda61d00a61a7da701efa3ef332267d3724424
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-21 00:26:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-21 00:26:02 +0900

    [DOC] Enhancements for globals.md (#15545)

    * [DOC] Enhancements for globals.md

  Notes:
    Merged-By: BurdetteLamar <BurdetteLamar@Yahoo.com>

commit 6bf921051ceba1742318e3c92dddd50ba4f05d17
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 07:16:01 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 22:40:00 +0900

    [ruby/mmtk] Call rb_bug when Ruby mutator thread panics

    This will allow the Ruby backtrace, memory mapping, etc. to be outputted
    when a Ruby mutator thread panics.

    https://github.com/ruby/mmtk/commit/d10fd325dd

commit e6520de3442659def3463d3bfdca3432f41b2d6a
  Author:     Mike Dalessio <mike@37signals.com>
  AuthorDate: 2025-12-18 07:28:47 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-20 22:24:52 +0900

    [Bug #21792] Build rubyspec-capiext only when excuting `test-spec`

    rubyspec-capiext is only needed for running specs, not for building or
    installing Ruby.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15668

commit e4bcb64be1fe25c93a8f609a108d8d4c933d6a2f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-20 20:08:28 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-20 22:12:35 +0900

    [Doc] prefer encoding objects over encoding names

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15666

commit 8f7c3603c1b168e4f7440216b197f11325e31fdf
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-20 21:37:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-20 21:37:45 +0900

    Fix a fragile test

    `Dir.mktmpdir` concatenates a random base-36 number separated by "-",
    so may generate pathnames containing "-j4".

commit a57039196f0ef5a3ee8710d85e52e8644b9bc0c2
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2025-12-20 20:26:12 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-20 20:26:12 +0900

    Add clarifications about the Enumerator.size (#15615)

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit ec4ca91319212ac9109ceac305f527c998da1738
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2025-12-20 20:07:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-20 20:07:38 +0900

    Small documentation adjustments for new/updated features (#15634)

    * Document Range#to_set

    * Update Thread#raise and Fiber#raise signatures and docs

    * Add reference to String#strip to character_selectors.rdoc

    * Update *nil docs when calling methods

    * Enhance Array#find and #rfind docs

    * Add a notice to Kernel#raise about cause:

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit 77c3a9e447ec477be39e00072e1ce3348d0f4533
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-20 16:12:52 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-20 16:59:51 +0900

    Revert pack/unpack support for LEB128

    https://bugs.ruby-lang.org/issues/21785#note-10
    > It is too late to introduce it in Ruby 4.0, let's aim for 4.1.

    This reverts commits:

    * d0b72429a93e54f1f956b4aedfc25c57dc7001aa
      Add support for signed and unsigned LEB128 to pack/unpack.

    * 68a900e30b4ca1537d7975c3a619fd94fca7b084
      add news for pack / unpack directives

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15665

commit 49f9c9bff29bce267b6aa362c6004d98db5c62f3
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-20 16:14:38 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-20 16:18:33 +0900

    Box: [DOC] Update the name from Namespace

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15664

commit 029112359914af51f50917878d4f547864a228c6
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-12-19 23:33:35 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-20 14:54:45 +0900

    fix for a test case that depends on rbuf size

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15654

commit 43b67356bcd636d92ec17bc48c1a492677a5b615
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-12-19 01:06:22 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-20 14:54:45 +0900

    remove obsolete workaround

    This appears to be a workaround for Windows XP behavior. It is unnecessary now.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15654

commit df68535055c2104dc97762aeb3ed2794f01c49cf
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-20 07:12:03 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 11:38:12 +0900

    [DOC] Improve docs for Signal.trap

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15659

commit b7d4d7c911e1aa3882b1186ba0ba780801ab27ea
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-20 09:19:54 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 11:36:46 +0900

    [DOC] Harmonize several <=> methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15660

commit bb0637a92f94dc0aa00e7dd8de4455bb23204068
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-20 11:22:00 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-20 11:27:01 +0900

    ZJIT: [DOC] Fix link to in-repo file. Mention GNU Make requirement

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15662

commit 8274c5e1428b5b88e885857d466822cbadc19761
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-19 10:01:13 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 07:14:02 +0900

    [ruby/mmtk] Extract max object size to MMTK_MAX_OBJ_SIZE

    https://github.com/ruby/mmtk/commit/ed9036c295

commit ed0fae5b501dea14617103ab5ec2d042f445ed7f
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-19 10:00:13 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 07:13:49 +0900

    [ruby/mmtk] Extract heap count to MMTK_HEAP_COUNT macro

    https://github.com/ruby/mmtk/commit/4e789e118b

commit 42c4df9ac6d5974eac7efddf725ecf39f4c0fd9e
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-20 05:06:49 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 07:09:31 +0900

    [DOC] Harmonize String#<=>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15658

commit d540903ee77e81dd1ec3dec744273fbb394238fa
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-19 21:45:36 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-20 07:09:10 +0900

    [DOC] Harmonize <= methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15653

commit d9c0d4c71cd3500b2307c518b423ee58eeff9ae5
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 19:21:55 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-20 05:06:29 +0900

    Don't copy invalidated CME in rb_vm_cc_table_dup

    The cc_entries list associated with the invalidated CME can be deleted
    from the table during GC, so it isn't safe to copy (and we shouldn't
    copy it anyways, it's stale data).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15652

commit 04e90fe200d736db0a32a794b8dc742fa0cb5441
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-20 03:49:50 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-12-20 03:49:50 +0900

    skip TestFiberScheduler#test_io_write_on_flush because it makes GC.stat test fragile

commit 8c7e6f241f5939eb572a47fd99bf626413eb2907
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-19 21:58:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-19 21:58:05 +0900

    Update bundled gems list as of 2025-12-19

commit e23a918a711c719f6ac257c83b81284fd137c1f6
  Author:     Sharon Rosner <sharon@noteflakes.com>
  AuthorDate: 2025-12-19 20:02:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 20:02:57 +0900

    Update NEWS.md for Fiber Scheduler (#15629)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 9ee2243bede65fba8b7fbce54a232b8c063a5616
  Author:     Sharon Rosner <sharon@noteflakes.com>
  AuthorDate: 2025-12-19 19:58:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 19:58:26 +0900

    Fiber scheduler: invoke `#io_write` hook on IO flush (#15609)

    Previously, calling IO#flush or closing an IO with unflushed buffered
    writes would just invoke `#blocking_operation_wait` and flush the write
    buffer using a `write` syscall. This change adds flushing through the
    fiber scheduler by invoking the `#io_write` hook.

    * Prefer IO::Buffer#write in IOScheduler

    * Use Dir.tmpdir for test file

    * Correctly handle errors in io_flush_buffer_fiber_scheduler

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit dd2f7d6ae6ab53bea7a179338378e1d32c306747
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-19 13:51:27 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-19 19:48:43 +0900

    [Bug #21794] Fix for platforms where O_CLOEXEC is not available

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15650

commit f0472f2d49c896bf072d327ff2a4ee009115266f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-19 17:16:15 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-19 17:16:15 +0900

    [Feature #21785] [DOC] LEB128 support

commit 7b19f1a1ef4c66a8a8f8fb64cb08ecca2044884c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-19 14:24:33 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-19 16:36:44 +0900

    Skip RBS Ractor test on Windows

    It seems hunging up.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15649

commit 8efaf5e6b6a25e0d237f3d71b75865661ae98268
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-19 15:54:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-19 15:55:50 +0900

    Adjust Stdlib section with 4.0.0 and added reference of RubyGems release notes.

commit 47244b0f306161f175b21f74d801882e950e18be
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-19 15:44:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 15:44:35 +0900

    Fix: Specifying 0 should cause an immediate timeout (#15641)

    This change fixes a bug in which specifying 0 for timeout-related options (such as the `timeout` option of `Addrinfo.getaddrinfo`) incorrectly results in an infinite wait.

    (This change overwrites https://github.com/ruby/ruby/pull/15626 .)

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit f81c62be3df7b29c4c3b6adaa16599b38d0c0c46
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2025-12-19 11:46:58 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2025-12-19 14:39:12 +0900

    Terminate `args_tail_basic` rule with a semicolon

    Semicolon is optional however it clarifies the end of the rule.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15648

commit 6f6ea70dcea1bbcb00774c1da58735a78c8924c2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-19 09:47:22 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-19 13:36:43 +0900

    Just passing FDs does not need to create IO objects

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15644

commit bfba65d8c1fcdc75ea3fc0f78d8bc7514e7afabd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-19 09:26:23 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-19 13:36:42 +0900

    Extract `Test::JobServer` module

    A placeholder to handle GNU make jobserver option.
    spec/default.mspec didn't handle the jobserver using a FIFO.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15644

commit 42d66b894cdfa356ed67af3000f79f7b2e9185fe
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-19 12:12:12 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 12:12:12 +0900

    Fix: Do not check open_timeout twice (#15626)

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit 305f04210545d6801b2a4821a91858f0aed84f01
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-19 10:26:59 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-19 11:58:25 +0900

    NEWS.md: Sort items in alphabetical order

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15642

commit b90d3a6beef7e960dca737efcbff18f8fffa31c0
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-19 11:44:57 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-19 11:44:57 +0900

    Update bundled gems list as of 2025-12-19

commit 81ad407475149ea47a78875444e0aef5ee4f6635
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2025-12-19 11:43:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 11:43:58 +0900

    Fix rbs test failure caused by minitest-6 (#15643)

    * Fix rbs test failure caused by minitest6
    * Bundle minitest-6.0.0

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 68a900e30b4ca1537d7975c3a619fd94fca7b084
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-12-19 10:03:15 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2025-12-19 10:57:00 +0900

    add news for pack / unpack directives

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15640

commit 5c0c0dd8737c8225f0ebcf0eaf3fb8b71917ee4d
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-19 00:10:13 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-12-19 09:58:53 +0900

    [ruby/prism] Bump to v1.7.0

    https://github.com/ruby/prism/commit/21c499d6e4

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15630

commit e2c886dd669dd640dae75e3ac6d7206b74870d1b
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-12-02 05:13:25 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-12-19 09:58:53 +0900

    [ruby/prism] Reject `p(p a, &block => value)` and similar

    Redo of https://github.com/ruby/prism/pull/3669 with more tests

    https://github.com/ruby/prism/commit/48b403ea79

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15630

commit 76248400b75d42288a5941aa03e2d2e6d4fac057
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-12-17 18:47:43 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-12-19 09:58:53 +0900

    [ruby/prism] Add Ruby 4.1 as a version specifier

    https://github.com/ruby/prism/commit/138db9ccc4

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15630

commit d9b03c9369001a835b186ee7fd637e7f94d3d64f
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-16 23:39:00 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-12-19 09:58:53 +0900

    [ruby/prism] Fix assertions in location_test.rb

    * assert_raise's 2nd argument is the failure message,
      shown when the expected exception is not raised.
      It's not the expected message.
      See https://github.com/test-unit/test-unit/issues/347

    https://github.com/ruby/prism/commit/e3df994d47

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15630

commit 0c4fcdff3252cca0d50986fc5b54a41bff809c85
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 08:48:06 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 09:47:35 +0900

    Update ArgumentError message for Ractor.select

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15639

commit b14f2f0116e6eccbfff57edae1283b3c53247752
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-19 09:21:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 09:21:00 +0900

    [DOC] Harmonize lt methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15593

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 084b916a5b9da0367b077add3203b924e868970b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-17 09:10:11 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 09:00:35 +0900

    [DOC] Update NEWS for implementation improvements

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15595

commit 805f53a9b12d82830db2f523d975eff2bd71bfa5
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-17 09:13:44 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 09:00:35 +0900

    [DOC] Various improvements to NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15595

commit 535233c68c30546c81d22694fa3f5911d74c14b6
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 08:48:29 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 08:59:49 +0900

    [DOC] Update ractor.rb docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15638

commit 3c6a6afa1c166b9fd24761c65fbd1268cb020341
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 08:33:34 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 08:59:49 +0900

    [DOC] Update ractor.c docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15638

commit 99b915944f1d47c1a47b1a3e894013869c7c27a7
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-17 08:21:14 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-19 07:47:18 +0900

    [DOC] Russian strings should look Russian

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15594

commit d0b72429a93e54f1f956b4aedfc25c57dc7001aa
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-12-17 02:10:45 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2025-12-19 07:42:47 +0900

    Add support for signed and unsigned LEB128 to pack/unpack.

    This commit adds a new pack format command `R` and `r` for unsigned and
    signed LEB128 encoding.  The "r" mnemonic is because this is a
    "vaRiable" length encoding scheme.

    LEB128 is used in various formats including DWARF, WebAssembly, MQTT,
    and Protobuf.

    [Feature #21785]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15589

commit 73e930f9f911cf71ecb416c3112a7818bae41cd6
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 05:31:34 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 06:43:45 +0900

    JIT: Move EC offsets to jit_bindgen_constants

    Co-authored-by: Alan Wu <alanwu@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15361

commit b1c3060beda4bd659d21a2b2ea598bf9ee819d70
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 05:31:07 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 06:43:45 +0900

    Co-authored-by: Luke Gruber <luke.gru@gmail.com>
    Co-authored-by: Alan Wu <alanwu@ruby-lang.org>

    YJIT: Support calling bmethods in Ractors

    Co-authored-by: Luke Gruber <luke.gru@gmail.com>

    Suggestion from Alan

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15361

commit 345ea0c8e18d3ce8fed332137d225769df619f2b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-18 05:08:43 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 06:43:45 +0900

    YJIT: Support calling bmethods in Ractors

    Co-authored-by: Luke Gruber <luke.gru@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15361

commit 63b082cf0e87942dcea28cbdeb1c8a9e616e903a
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-18 05:12:17 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 06:43:45 +0900

    Store ractor_id directly on EC

    This is easier to access as ec->ractor_id instead of pointer-chasing through
    ec->thread->ractor->ractor_id

    Co-authored-by: Luke Gruber <luke.gru@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15361

commit aace29d485559e38ca06923a6af335dbb5fb28f1
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-19 05:42:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 05:42:49 +0900

    Check for NULL fields in TYPEDDATA memsize functions (#15633)

    Some TYPEDDATA objects allocate struct fields using the GC right after
    they get created, and in that case the VM can try to perform a GC and join
    a barrier if another ractor started one. If we're dumping the heap in another
    ractor, this acquires a barrier and it will call the `rb_obj_memsize` function on this
    object. We can't assume these struct fields are non-null. This also goes for C extensions,
    which may cause problems with heap dumping from a ractor if their memsize functions aren't
    coded correctly to check for NULL fields. Because dumping the heap from a ractor is likely a
    rare scenario and it has only recently been introduced, we'll have to see how this works in
    practice and if it causes bugs.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit a7eb1879ad35a0b5d9d32fcdbf2f840bd2c8858c
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-19 05:08:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 05:08:36 +0900

    [DOC] small improvements to ractor class docs (#15584)

    * Ractor.yield no longer exists
    * Ractor.shareable_proc returns a copy of the given proc
    * Improve wording for monitoring/unmonitoring ports

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit fb1dd92d30a8df93f6fe2746aacc097f4c3ea62b
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-19 04:17:45 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-19 05:07:55 +0900

    thread_sync.c: rename mutex_trylock internal function

    [Bug #21793]

    To fix a naming conflict on solaris.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15635

commit 8cf4f373ff596aaef7aaec993c355b242d4fe2c1
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-18 17:35:44 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-19 04:57:05 +0900

    thread_sync.c: declare queue_data_type as parent of szqueue_data_type.

    Allows to remove some duplicated code like szqueue_length, etc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15623

commit bbc684d8300fc3fc02020a9a644b857d090f2215
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-18 17:11:53 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-19 04:57:05 +0900

    thread_sync.c: simplify `check_array`

    If the queue was allocated without calling initialize,
    `ary` will be `0`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15623

commit 57c4cd9a474ccd32caccee28a850ff8a041babb8
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-17 17:22:54 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-19 04:57:05 +0900

    thread_sync.c: eliminate GET_EC() from queue_do_pop

    We receive the ec as argument, it's much cheaper to pass it
    around that to look it up again.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15623

commit 28c2a5b2a4db5ed6faa7cf3d71baf2765a277184
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-18 13:21:17 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-19 04:03:23 +0900

    Fix env debug assertion failure w/ Ractors+JITs

    Previously when using a JIT and Ractors at the same time with debug
    assertions turned on this could rarely fail with:

        vm_core.h:1448: Assertion Failed: VM_ENV_FLAGS:FIXNUM_P(flags)

    When using Ractors, any time the VM lock is acquired, that may join a
    barrier as another Ractor initiates GC. This could be made to happen
    reliably by replacing the invalidation with a call to rb_gc().

    This assertion failure happens because

        VM_STACK_ENV_WRITE(ep, 0, (VALUE)env);

    Is setting VM_ENV_DATA_INDEX_FLAGS to the environment, which is not a
    valid set of flags (it should be a fixnum). Although we update cfp->ep,
    rb_execution_context_mark will also mark the PREV_EP, and until the
    recursive calls to vm_make_env_each all finish the "next" ep may still
    be pointing to the stack env we've just escaped.

    I'm not completely sure why we need to store this on the stack - why is
    setting cfp->ep not enough? I'm also not sure why
    rb_execution_context_mark needs to mark the prev_ep.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15621

commit 74bfb1606d09672a37105c138edf8e0d8acbb5c1
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-19 03:51:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 03:51:33 +0900

    Remove assertion in encoded_iseq_trace_instrument (#15616)

    `encoded_iseq_trace_instrument` is safe to call in a ractor if the iseq
    is new. In that case, the VM lock is not taken. This assertion was added in
    4fb537b1ee28bb37dbe551ac65c279d436c756bc.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 0e719239c2fa39804cdbf1f920a18fcec919e2ce
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-18 17:47:26 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-19 03:37:14 +0900

    thread_sync: Mutex keep `rb_thread_t *` instead of `VALUE`

    We never need the actual thread object and this avoid any issue
    if the thread object is ever moved.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15625

commit bfd28d581c524c7a7df877f2425de9fdd8de161a
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-19 02:37:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 02:37:27 +0900

    make rb_singleton_class ractor safe (#15591)

    Since singleton classes are created lazily, we need to make sure that
    we lock around their creation.  Unfortunately, that means we need to
    lock around every shareable object's call to `singleton_class`,
    including classes and modules.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit f133ebb2db664801f87efa98aa91d610d194b700
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2025-12-19 01:12:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-19 01:12:47 +0900

    Bump RDoc to 7.0.1 (#15628)

    This improves several enhancements to the Aliki theme. And since Aliki
    also became the default theme, we don't need to specify the generator name
    anymore.

  Notes:
    Merged-By: st0012 <stan001212@gmail.com>

commit 0e85881e0cded6ec82ef105b5ff2d0c6f7fdcbc8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-18 15:20:19 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    [ruby/delegate] v0.6.1

    https://github.com/ruby/delegate/commit/90ffceb6d6

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit 000659140786f1c74075b1b91ce03897cf525181
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-18 14:17:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    Reapply "Merge pull request #52 from ruby/revert-49"

    This reverts commit 02e4b58b615d0dd83a6af5cd7c2b8861724011ee.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit 2fcad967aab5aae921b2288c8080096d79ddb8dd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-18 14:16:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    Revert "Allow use of DelegateClass in ractor"

    This reverts commit 6e0f2b31f0f4a2a942f3c1daad1bb64852fe6815.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit 1e69d688e59e6fb82efff41f966be3b55561b349
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-18 13:58:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    [ruby/delegate] v0.6.0

    https://github.com/ruby/delegate/commit/aef34e8c8b

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit e6ca8908c1c2a53e5d73c1628f42c84d87b2a5d0
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-18 06:34:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    Allow use of DelegateClass in ractor

    Use `eval` instead of `define_method` when defining delegate methods for
    `DelegateClass`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit a21fe2adfe3b4e4496f89e35d5a5a8cf11bf1ca0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 12:56:19 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    [ruby/delegate] Reapply "Merge pull request #46 from byroot/use-forward-send"

    This reverts commit https://github.com/ruby/delegate/commit/fc2bd0498af0.

    https://github.com/ruby/delegate/commit/7d5c1e0842

    Co-authored-by: Jean Boussier <byroot@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit bdf99bf0dc3adf15f653dd8c02fce9d6ba946af5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 12:59:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    [ruby/delegate] v0.5.0

    https://github.com/ruby/delegate/commit/fa35b20eca

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit 01e9f95cc3d796bc7bf4f809016712c52f330d74
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-13 03:54:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-18 16:46:29 +0900

    [ruby/delegate] Allow use of DelegateClass in ractors

    Tempfile uses DelegateClass and Tempfile should be able to be used
    by different ractors.

    https://github.com/ruby/delegate/commit/cad194260b

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15605

commit 85ff21c9e5986c52814b7e5ed3402e2a964c542e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-18 15:42:36 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-18 16:42:20 +0900

    RBOOL is unnecessary in C boolean context

    Fix a `-Wint-in-bool-context` warning.

    ```
    proc.c:688:33: warning: '?:' using integer constants in boolean context [-Wint-in-bool-context]
      688 |     if (RBOOL(get_local_variable_ptr(&env, idItImplicit, FALSE))) {
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15622

commit 769c6a1c54e68d0100054e51fc25e1a6355645c8
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-15 22:47:54 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-18 14:22:39 +0900

    [DOC] Use Arrays in examples for Array#find

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15559

commit b816f7bac5f2dfb10c7a468c14cfcdedaab2f7ae
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-18 11:27:05 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-18 11:27:05 +0900

    [DOC] Fix documents of `rb_intern_str` and so on

    * `rb_intern_str`: the argument must be `T_STRING`, no conversion.

    * `rb_intern_str`, `rb_check_id`, `rb_to_id`, `rb_check_symbol`: raise
      `EncodingError` unless the "name" argument is a valid string in its
      encoding.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15620

commit f2d2a757d1b3a11b68e60ee08162e58f59837bb3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-18 10:14:40 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-18 10:14:40 +0900

    [DOC] Re-fill the paragraph

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15620

commit cfa3e7cf75531a8c90b39bbd9b977f30315b12e7
  Author:     Augustin Gottlieb <33221555+aguspe@users.noreply.github.com>
  AuthorDate: 2025-12-18 09:34:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-18 09:34:32 +0900

    [DOC] Fix double-word typos in comments

    Found via `grep` for repeated words.

    * set.c: Fix "or or"
    * include/ruby/internal/symbol.h: Fix "is is"
    * include/ruby/internal/ctype.h: Fix "in in"

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15619

    Merged-By: nobu <nobu@ruby-lang.org>

commit 656de67d5c8cd894eeda0baa618663098dce17f2
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-18 03:51:12 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-18 04:49:32 +0900

    JITs: Pass down GNU make jobserver resources when appropriate

    To fix warnings from rustc on e.g. Make 4.3, which is in Ubuntu 24.04:

    > warning: failed to connect to jobserver from environment variable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15613

commit ef3ac3e68c20276eed3de756c1260f43d94746d3
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2025-12-18 04:22:55 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-18 04:22:55 +0900

    Adjust Set documentation (#15547)

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit 839410f0734cb3ed911d348855f69ff6d856f62b
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-18 03:18:58 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-18 04:12:57 +0900

    Fix heap dump with ractor barrier

    When a ractor was being initialized and it would join the heap dump barrier when
    allocating its queue or its ports, the heap dump code calls `rb_obj_memsize` on
    the ractor and this function assumed `ports` was never NULL. We need to check for
    the NULL case in case the ractor is still being initialized. Hopefully other T_DATA
    objects don't suffer from the same issue, otherwise we could revert the ractor barrier
    during heap dump or not use `rb_obj_memsize` on T_DATA during the heap dump.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15612

commit 601ac78caf1523170b2f88767d67ffa5e8c5b1bc
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-18 04:00:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-18 04:00:58 +0900

    [DOC] Small changes to docs for ObjectSpace#each_object (#15564)

    Change example to use user-defined class instead of `Numeric`.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit f7120860b0a76fd776ef4bf040e42a46c8aeff63
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-18 03:44:28 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-18 03:45:57 +0900

    test_sync_default_gems.rb: Omit if git is v2.43 or older

commit dc2a62e14c4691808f04ea0cb2de30c681e87923
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-18 03:18:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-18 03:22:00 +0900

    test_commit_email.rb: Ensure #teardown doesn't fail

    if test is omitted.

    Follow up c4e090def134f9b109991b74c027648564963763

commit a9526ab50ca693755cd841da1c73855448453dfb
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-18 03:05:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-18 03:05:21 +0900

    Update bundled gems list as of 2025-12-17

commit 7e13fbc0ed013d03444158cda7e800e9c0eb4ddf
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2025-12-18 03:04:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-18 03:04:49 +0900

    Update bundled bigdecimal and rbs (#15611)

    * Bundle rbs-3.10.0.pre.1

    * Update rbs gem entry with commit hash

    Updated rbs entry to include commit hash.

    * Fix rbs entry in bundled_gems

    * Update rbs gem to version 3.10.0.pre.2

    Updated rbs gem version from 3.10.0.pre.1 to 3.10.0.pre.2.

    * Update bundled bigdecimal to v4.0.1

    ---------

    Co-authored-by: Soutaro Matsumoto <matsumoto@soutaro.com>

  Notes:
    Merged-By: tompng <tomoyapenguin@gmail.com>

commit 56b67f1684bf1955cf69fc06701e2a710898bd9b
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-18 02:17:30 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-18 02:17:30 +0900

    ObjectSpace.{dump,dump_all,dump_shapes} needs vm barrier. (#15569)

    This allows these methods to be called from ractors.

    Add new exported function `rb_vm_lock_with_barrier()` that requires
    users to include "vm_sync.h"

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 41e24aeb1a432c13ff484a055077d00d93668201
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-17 22:06:53 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 22:06:53 +0900

    Improve NEWS.md for Socket (#15610)

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit aee4b24829cfd26c9089f539179bd7770d283bfa
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-17 13:26:55 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-17 21:11:27 +0900

    [ruby/error_highlight] Show no message when failing to get caller/callee snippets

    Even with Ruby 4.0, snippets is not always available, such as in irb by
    default. It would be better to just say nothing than to show a confusing
    message.

    https://github.com/ruby/error_highlight/commit/ef80ce73a1

commit c99670d6683fec770271d35c2ae082514b1abce3
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2025-12-17 18:36:10 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2025-12-17 18:56:22 +0900

    Revert the default size of Enumerator::Producer to infinity

    [Bug #21780]

commit f45b1e3a1bfff6546a63d741c404fc404fa91cc6
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-17 18:53:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 18:53:34 +0900

    Update NEWS.md for Socket (#15608)

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit bd4353ba7aeb464c9736fe49ac017899b2295d60
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-16 18:10:51 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 17:38:52 +0900

    CI: Assume all C source files are UTF-8 now

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15579

commit f286e7001930dc1e13c9235b83af32216fde8d5c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-10-08 12:09:15 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 17:38:52 +0900

    win32: Set the source code charset to UTF-8

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15579

commit 61bab1889048f758396acf671c9797d6bc52504b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-17 14:28:03 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 17:35:58 +0900

    Rename to `struct rbimpl_size_overflow_tag`

    This struct is used for addition not only for multiplication, so
    remove the word `mul`, and make the member names more descriptive.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15607

commit 79f36c544a0431d9b76c3c11a5f622383eaca7bd
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2025-12-17 17:30:24 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2025-12-17 17:30:24 +0900

    Revert the override of Enumerator#to_set that performed size checks

    [Bug #21780]

commit 54d3945ee53fa29186c6aa44f673a3a5ec3b38d9
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-17 16:16:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 16:16:32 +0900

    Add host information to timeout error messages in `TCPSocket.new` and `Socket.tcp` (#15582)

    This change adds host information to the error messages shown when a timeout occurs while passing timeout options to `TCPSocket.new` or `Socket.tcp`, for improved usability.
    (When the `fast_fallback option` is enabled, there may be multiple possible destinations, so the host name is shown instead of an IP address.)

    As part of this change, the error messages in `Addrinfo.getaddrinfo` and `Addrinfo#connect_internal`, both of which are used by `Socket.tcp`, have also been improved in the same way.

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit 1506c489eef67f268a54484662011a60897bdd48
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-17 13:04:06 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-17 16:12:28 +0900

    Update NEWS.md for improvements of error backtrace

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15604

commit 26447b3597ab95af7cc220c641a1bd58b235fec9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 15:03:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    [ruby/net-http] v0.9.1

    https://github.com/ruby/net-http/commit/8cee86e939

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit b80fc8bd84d194fdab60d0aee14ce0850a366500
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-13 17:30:21 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    [ruby/net-http] Freeze more constants for Ractor compatibility

    Freeze Net::HTTP::SSL_ATTRIBUTES and IDEMPOTENT_METHODS_. Both constants
    have been marked as :nodoc:.

    Together with https://github.com/ruby/openssl/issues/521, this enables
    HTTPS clients in non-main Ractors on Ruby 4.0.

    https://github.com/ruby/net-http/commit/f24b3b358b

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit fedafec78b2e6aa17a4246192a40192d7a0cf69c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 13:28:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    [ruby/net-http] v0.9.0

    https://github.com/ruby/net-http/commit/3ccf0c8e6a

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit df18f3baa658174ef89c8c2c11be4fea9bda4fc7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 14:38:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    Bundle strscan-3.1.6

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit d5257bea4811e54c006c4f2f56344d0d155638c9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 14:38:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    Bundle stringio-3.2.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit 8e258121942e7c879bc11d221425ac39f73afe8c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 13:23:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    [ruby/timeout] v0.6.0

    https://github.com/ruby/timeout/commit/ab79dfff47

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit 01624492ecb14d85e26023169bf8b36c6015c62d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 13:32:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    [ruby/time] v0.4.2

    https://github.com/ruby/time/commit/387292f5d2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit 8850807eb1d8e6376a4f0dd99cb2f5e3e2988595
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 13:34:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 15:47:43 +0900

    [ruby/psych] v5.3.1

    https://github.com/ruby/psych/commit/8345af9ffb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15603

commit 7b5691c3b000c763faa282e1f73db96afa2ecae1
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-17 15:02:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 15:02:26 +0900

    `Socket.tcp` and `TCPSocket.new` raises `IO::TiemoutError` with user specified timeout (https://github.com/ruby/net-http/pull/15602)

    * `Socket.tcp` and `TCPSocket.new` raises `IO::TiemoutError` with user specified timeout

    In https://github.com/ruby/ruby/pull/11880, `rsock_connect()` was changed to raise `IO::TimeoutError` when a user-specified timeout occurs.
    However, when `TCPSocket.new` attempts to connect to multiple destinations, it does not use `rsock_connect()`, and instead raises `Errno::ETIMEDOUT` on timeout.
    As a result, the exception class raised on timeout could differ depending on whether there were multiple destinations or not.

    To align this behavior with the implementation of `rsock_connect()`, this change makes `TCPSocket.new` raise `IO::TimeoutError` when a user-specified timeout occurs.
    Similarly, `Socket.tcp` is updated to raise `IO::TimeoutError` when a timeout occurs within the method.
    (Note that the existing behavior of `Addrinfo#connect_internal`, which Socket.tcp depends on internally and which raises `Errno::ETIMEDOUT` on timeout, is not changed.)

    * [ruby/net-http] Raise `Net::OpenTimeout` when `TCPSocket.open` raises `IO::TimeoutError`.

    With the changes in https://github.com/ruby/ruby/pull/15602, `TCPSocket.open` now raises `IO::TimeoutError` when a user-specified timeout occurs.
    This change updates #connect to handle this case accordingly.

    https://github.com/ruby/net-http/commit/f64109e1cf

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit 0e2962f917db1b20a6d34b6105b3768af8e692b8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-17 14:14:36 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-17 14:16:38 +0900

    [ruby/io-wait] bump up to 0.4.0

    https://github.com/ruby/io-wait/commit/ae676c9d6d

commit e354e9ba1007c10df3ee843bb9daabd89b47a708
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-17 11:57:57 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-17 12:37:13 +0900

    refactor: utilize a predefined macro

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15601

commit 7c402d2c2757b38df8b9406b372d2e1f406296ae
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-11 15:27:05 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 12:35:38 +0900

    IO::Buffer: Warn as experimental at allocation

    Previously, warned only in `new` and `map`, but not `for` and
    `string`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15599

commit c353b625297162024b5a80480664e599dd49a294
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-22 23:43:19 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 12:35:38 +0900

    [Bug #21787] IO::Buffer: Check addition overflows

    https://hackerone.com/reports/3437743

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15599

commit 9519d16381c8a8ddf7e1128a08fd80dfac8ed327
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-22 23:41:23 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 12:35:38 +0900

    IO::Buffer: Guard arguments from GC

    At least, `string` in `io_buffer_set_string` can be different from
    `argv[0]` after `rb_str_to_str` call.  The other cases may not be
    necessary.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15599

commit f430fbbfacea5690d790dd9060ca4118431fc2fb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-22 23:40:35 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-17 12:35:38 +0900

    IO::Buffer: Fill the test for `IO::Buffer#clear`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15599

commit 3b66efda523fc33070aee6097898dbc5b1af6f4b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 11:29:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 12:12:34 +0900

    Bundle RubyGems 4.0.2 and Bundler 4.0.2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15600

commit 2117e612cafbd1a5ce4ce1d72cc13f8d9b715aa9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-17 10:38:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-17 11:11:52 +0900

    Disabled gem sync for Ruby 4.0 release

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15598

commit 74a365310cfd150af6b45920d84920d17d6b3946
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-17 11:11:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 11:11:39 +0900

    Fix: Recalculate the timeout duration considering `open_timeout` (#15596)

    This change updates the behavior so that, when there is only a single destination and `open_timeout` is specified, the remaining `open_timeout` duration is used as the connection timeout.

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit f483484fc610589a6faf828a77fd76f15fb4ebb3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-17 07:49:55 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-17 11:03:57 +0900

    [DOC] Fix call-seq of Method#box

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15592

commit 0fe111caa6885407960541bdb6de7ba3cd6aad73
  Author:     Daisuke Aritomo <osyoyu@osyoyu.com>
  AuthorDate: 2025-12-16 15:15:28 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-17 10:15:59 +0900

    Respect encoding of ID in exception messages

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15556

commit cbcbbb2fbe57fb17b3bd6b93244c4f37f3626c7e
  Author:     Daisuke Aritomo <osyoyu@osyoyu.com>
  AuthorDate: 2025-12-15 18:04:57 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-17 10:15:59 +0900

    Let Ractor::IsolationError report correct constant path

    Before this patch, Ractor::IsolationError reported an incorrect constant
    path when constant was found through `rb_const_get_0()`.

    In this code, Ractor::IsolationError reported illegal access against
    `M::TOPLEVEL`, where it should be `Object::TOPLEVEL`.

    ```ruby
    TOPLEVEL = [1]

    module M
      def self.f
        TOPLEVEL
      end
    end

    Ractor.new { M.f }.value
    ```

    This was because `rb_const_get_0()` built the "path" part referring to
    the module/class passed to it in the first place. When a constant was
    found through recursive search upwards, the module/class which the
    constant was found should be reported.

    This patch fixes this issue by modifying rb_const_search() to take a
    VALUE pointer to be filled with the module/class where the constant was
    found.

    [Bug #21782]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15556

commit 2d0140664436d85684a98a81f4fb103c186895b9
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-17 06:27:09 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-17 07:47:08 +0900

    [DOC] Harmonize rb_div methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15590

commit 5e27581c3b3782f731ada9f83129c5c17a8f8c49
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-17 00:31:29 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    ZJIT: Use rb_zjit_writebarrier_check_immediate() instead of rb_gc_writebarrier() in gen_write_barrier()

    * To avoid calling rb_gc_writebarrier() with an immediate value in gen_write_barrier(),
      and avoid the LIR jump issue.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15542

commit cc048f7571c5d054b04dad39cb61d008b30f663a
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-17 00:23:29 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    Revert "ZJIT: Do not call rb_gc_writebarrier() with an immediate value in gen_write_barrier()"

    * This reverts commit 623559faa3dd0927b4034a752226a30ae8821604.
    * There is an issue with the jump in LIR, see https://github.com/ruby/ruby/pull/15542.

commit 04edf3d9939d08f4e724cb91b9be374032cb662e
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-16 21:02:33 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    ZJIT: Add a VALUE#write_barrier helper method to deduplicate logic

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15542

commit 49cecd360fe61ec266c230084f46d5b640c03399
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-16 20:42:09 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    ZJIT: Guard other calls to rb_gc_writebarrier() with a !special_const_p() check

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15542

commit 68174c31e4de2e63dbe32065a5d42c909963cdb8
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-16 20:10:28 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    ZJIT: Do not call rb_gc_writebarrier() with an immediate value in gen_write_barrier()

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15542

commit 4d4f414a6062173743af7fe2b88835f16287a6cc
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-16 19:58:49 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    Use RBIMPL_ASSERT_OR_ASSUME instead of ASSUME for better errors when it does not hold

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15542

commit 094418a6de89a37fc51a17077a5565f125b97f2e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-14 17:50:21 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-17 05:00:27 +0900

    gc.h: Reintroduce immediate guard in `rb_obj_written`

    This guard was removed in https://github.com/ruby/ruby/pull/13497
    on the justification that some GC may need to be notified even for
    immediate.

    But the two currently available GCs don't, and there are plenty
    of assumtions GCs don't everywhere, notably in YJIT and ZJIT.

    This optimization is also not so micro (but not huge either).
    I routinely see 1-2% wasted there on micro-benchmarks.

    So perhaps if in the future we actually need this, it might make
    sense to introduce a way for GCs to declare that as an option,
    but in the meantime it's extra overhead with little gain.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15542

commit eaa952b536c48658a5a2e3f128e3afdef03a01b6
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-17 03:33:47 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-17 04:56:40 +0900

    YJIT: Print `Rc` strong and weak count on assert failure

    For <https://bugs.ruby-lang.org/issues/21716>, the panic is looking like
    some sort of third party memory corruption, with YJIT taking the fall.
    At the point of this assert, the assembler has dropped, so there's
    nothing in YJIT's code other than JITState that could be holding on to
    these transient `PendingBranchRef`.

    The strong count being more than a handful or the weak count is non-zero
    shows that someone in the process (likely some native extension)
    corrupted the Rc's counts.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15585

commit f3d1557d5c04d7bc0bfa931869fbb35d14592c53
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-17 04:53:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 04:53:31 +0900

    Revert "ZJIT: Allow ccalls above 7 arguments"

    This reverts commit 2f151e76b5dc578026706b31f054d5caf5374b05.

    The SP decrement (push) before the call do not match up with
    the pops after the call, so registers were restored incorrectly.

    Code from:

        ./miniruby --zjit-call-threshold=1 --zjit-dump-disasm -e 'p Time.new(1992, 9, 23, 23, 0, 0, :std)'

        str x11, [sp, #-0x10]!
        str x12, [sp, #-0x10]!
        stur x7, [sp]              # last argument
        mov x0, x20
        mov x7, x6
        mov x6, x5
        mov x5, x4
        mov x4, x3
        mov x3, x2
        mov x2, x1
        ldur x1, [x29, #-0x20]
        mov x16, #0xccfc
        movk x16, #0x2e7, lsl #16
        movk x16, #1, lsl #32
        blr x16
        ldr x12, [sp], #0x10       # supposed to match str x12, [sp, #-0x10]!, but got last argument
        ldr x11, [sp], #0x10

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15587

    Merged-By: XrXr

commit 4fb537b1ee28bb37dbe551ac65c279d436c756bc
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-17 04:06:55 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 04:06:55 +0900

    Make tracepoints with set_trace_func or TracePoint.new ractor local (#15468)

    Before this change, GC'ing any Ractor object caused you to lose all
    enabled tracepoints across all ractors (even main). Now tracepoints are
    ractor-local and this doesn't happen. Internal events are still global.

    Fixes [Bug #19112]

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit d209e6f1c0a93ad3ce1cc64dd165a6b67672614d
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-11-27 11:59:37 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-17 03:06:03 +0900

    search_nonascii(): Replace UB pointer cast with memcpy

    Casting a pointer to create an unaligned one is undefined behavior in C
    standards. Use memcpy to express the unaligned load instead to play by
    the rules.

    Practically, this yields the same binary output in many situations
    while fixing the crash in [Bug #21715].

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15572

commit a8ba2b295b73a116d24fe5602d892d4a2042cd08
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-12-17 02:15:46 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2025-12-17 02:44:44 +0900

    add 21254 to the feature list

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15583

commit aab4f6287da4d8035035f7486072f149abf8dcc9
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-17 01:47:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 01:47:13 +0900

    Add the instance variable name and the module in Ractor::IsolationError (#15563)

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 09a29e1312121fed5704ac196413c3b5ecb83fd7
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-17 01:06:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-17 01:06:33 +0900

    Add the class variable and the class itself in Ractor::IsolationError (#15562)

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 6b35f074bd83794007d4c7b773a289bddef0dbdf
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-16 22:17:08 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-16 22:23:24 +0900

    Box: [DOC] Add RUBY_BOX in Environment

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15581

commit 2b1a9afbfbb5491665bfbdd560486a310ca49755
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-12-16 19:52:45 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-16 19:52:45 +0900

    Fix: Do not pass negative timeout to Addrinfo#connect_internal (#15578)

    This change fixes a bug where, with `Socket.tcp`’s `fast_fallback option` disabled, specifying `open_timeout` could unintentionally pass a negative value to `Addrinfo#connect_internal`, `causing an ArgumentError`.

    ```
    ❯ ruby -rsocket -e 'p Socket.tcp("localhost", 9292, open_timeout: 1, fast_fallback: false)'
    /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:64:in 'IO#wait_writable': time interval must not be negative (ArgumentError)

              sock.wait_writable(timeout) or
                                 ^^^^^^^
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:64:in 'Addrinfo#connect_internal'
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:141:in 'Addrinfo#connect'
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:964:in 'block in Socket.tcp_without_fast_fallback'
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:231:in 'Array#each'
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:231:in 'Addrinfo.foreach'
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:945:in 'Socket.tcp_without_fast_fallback'
            from /Users/misaki-shioi/src/install/lib/ruby/4.0.0+0/socket.rb:671:in 'Socket.tcp'
            from -e:1:in '<main>'
    ```

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit e42bcd7ce76e75601ef3adf35467edf277471af2
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-16 08:43:41 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-16 17:51:07 +0900

    Rename fiber_serial into ec_serial

    Since it now live in the EC.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15543

commit 28b195fc67788c03be59c2a4cbf0cad52ac3b90f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-14 18:46:52 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-16 17:51:07 +0900

    Store the fiber_serial in the EC to allow inlining

    Mutexes spend a significant amount of time in `rb_fiber_serial`
    because it can't be inlined (except with LTO).
    The fiber struct is opaque the so function can't be defined as inlineable.

    Ideally the while fiber struct would not be opaque to the rest of
    Ruby core, but it's tricky to do.

    Instead we can store the fiber serial in the execution context
    itself, and make its access cheaper:

    ```
    $ hyperfine './miniruby-baseline --yjit /tmp/mut.rb' './miniruby-inline-serial --yjit /tmp/mut.rb'
    Benchmark 1: ./miniruby-baseline --yjit /tmp/mut.rb
      Time (mean ± σ):      4.011 s ±  0.084 s    [User: 3.977 s, System: 0.011 s]
      Range (min … max):    3.950 s …  4.245 s    10 runs

    Benchmark 2: ./miniruby-inline-serial --yjit /tmp/mut.rb
      Time (mean ± σ):      3.495 s ±  0.150 s    [User: 3.448 s, System: 0.009 s]
      Range (min … max):    3.340 s …  3.869 s    10 runs

    Summary
      ./miniruby-inline-serial --yjit /tmp/mut.rb ran
        1.15 ± 0.05 times faster than ./miniruby-baseline --yjit /tmp/mut.rb
    ```

    ```ruby
    i = 10_000_000
    mut = Mutex.new
    while i > 0
      i -= 1
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
      mut.synchronize { }
    end
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15543

commit 85b40c5ea8f606cf34cab8a5b1277033bede2457
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-16 09:01:14 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-16 16:53:13 +0900

    Box: fix the class name in tests

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15557

commit 5f09e1f046599c5466787449f5d30330d4dd4aab
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-15 21:28:17 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-16 16:53:13 +0900

    Box: [DOC] fix the class name in rdoc

    Also remove a stale TODO.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15557

commit 8db3642ab54f303b32a02bbfe53a2ab54725b046
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-15 21:13:11 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-16 16:53:13 +0900

    Box: fix the class name in inspect

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15557

commit 7780d3b6c303d00bc39d913dc91ff9f5f61ae9ed
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-15 21:12:07 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-16 16:53:13 +0900

    Box: fix the environment variable name

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15557

commit f4c48505ca50d021c3505fe422c04e4f41624bb2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-15 21:11:33 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-16 16:53:13 +0900

    Box: move extensions from namespace to box

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15557

commit 065c48cdf11a1c4cece84db44ed8624d294f8fd5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-16 12:51:45 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-16 16:13:07 +0900

    Revert "[Feature #6012] Extend `source_location` for end position
    and columns"

    This reverts commit 073c4e1cc712064e626914fa4a5a8061f903a637.

    https://bugs.ruby-lang.org/issues/6012#note-31
    > we will cancel this feature in 4.0 because of design ambiguities
    > such as whether to return column positions in bytes or characters as
    > in [#21783].

    [#21783]: https://bugs.ruby-lang.org/issues/21783

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15576

commit 5b0fefef417cad1733c18a0b66db07bcb1de5caf
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-16 14:50:44 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 15:28:36 +0900

    [ruby/rubygems] Added assertion for Windows and nmake

    https://github.com/ruby/rubygems/commit/be5c4e27d9

commit e4797e93213365956a6cec142122866c8f0c9a51
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-16 13:49:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 14:18:29 +0900

    [ruby/rubygems] Reset MAKEFLAGS option for build jobs tests

    https://github.com/ruby/rubygems/commit/09e6031a11

commit 080bf30c48a8212cf0ee4f769d1bdaa4a2df5900
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2025-12-10 22:29:32 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 13:21:49 +0900

    [ruby/rubygems] Allow to specify the number of `make` jobs when installing gems:

    - Added a new `-j` option to `gem install` and `gem update`.
      This option allows to specify the number of jobs we pass to `make`
      when compiling gem with native extensions.

      By default its the number of processors, but users may want a way
      to control this.

      You can use it like so: `gem install json -j8`

    https://github.com/ruby/rubygems/commit/67aad88ca6

commit 9f593156b6184718a65f99905e6b07002058ebe6
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2025-12-09 06:02:03 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 13:21:49 +0900

    [ruby/rubygems] Pass down value of `BUNDLE_JOBS` to RubyGems before compiling:

    - ### Problem

      Since https://github.com/ruby/rubygems/pull/9131, we are now
      compiling make rules simultaneously. The number of jobs
      is equal to the number of processors.
      This may be problematic for some users as they want to control
      this value.

      ### Solution

      The number of jobs passed to `make` will now be equal to the
      `BUNDLE_JOBS` value.

      ### Side note

      It's also worth to note that since Bundler installs gems in
      parallel, we may end up running multiple `make -j<JOB>` in parallel
      which would cause exhaust the number of processors we have.
      This problem can be fixed by implementing a GNU jobserver, which I
      plan to do. But I felt that this would be too much change in one PR.

    https://github.com/ruby/rubygems/commit/d51995deb9

commit 9168cad4d63a5d281d443bde4edea6be213b0b25
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-12-12 07:56:16 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-16 13:05:27 +0900

    YJIT: Bail out if proc would be stored above stack top

    Fixes [Bug #21266].

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15537

commit f3b9509b52bbf845d95bf799d76dad41783919e5
  Author:     hituzi no sippo <dev@hituzi-no-sippo.me>
  AuthorDate: 2025-12-13 15:53:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 12:56:22 +0900

    [ruby/rubygems] Fix quote handling in mise format ruby version parsing

    The previous regex didn't properly match quoted strings
    it would capture the opening quote as part of the version
    if quotes were mismatched.
    This change properly parses double-quoted, single-quoted,
    and unquoted version strings separately.

    https://github.com/ruby/rubygems/commit/81e48c8185

commit 3b50f4ba41ececd01dcf2e35c4071495f250d609
  Author:     hituzi no sippo <dev@hituzi-no-sippo.me>
  AuthorDate: 2025-12-11 19:16:17 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 12:56:21 +0900

    [ruby/rubygems] Support single quotes in mise format ruby version

    https://github.com/ruby/rubygems/commit/a7d7ab39dd

commit 3b3ab338516c9af009300761382f01a6beff4dd0
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2025-12-16 12:18:44 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2025-12-16 12:18:44 +0900

    ZJIT: Fix test failures from line number of `Primitive` shifting

    This can happen with documentation updates and we don't want
    those to trip on ZJIT tests.

    Redact the whole name since names like "_bi342" aren't that helpful
    anyways.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15575

commit 060199910afeccd4c81f90beebbd406799c05c46
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-16 11:09:34 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 11:36:10 +0900

    [ruby/rubygems] Allow to show cli_help with bundler executable

    https://github.com/ruby/rubygems/commit/a091e3fd10

commit b6d4562e6ae9cbf9864c3f35c361db8087e595e7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-15 07:34:34 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-16 09:25:15 +0900

    [DOC] Remove copyright from Set class docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15550

commit ff1b8ffa61922a46eae217c06aa16b24f26ae723
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2025-12-15 19:45:23 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 09:16:15 +0900

    [ruby/rubygems] Tweak the Bundler's "X gems now installed message":

    - Fix https://github.com/ruby/rubygems/pull/9188
    - This message is a bit misleading because it always outputs one extra
      specs, which is Bundler itself.

      This is now fixed when the message is about to be output.

    https://github.com/ruby/rubygems/commit/70b4e19506

commit f88e7970901d3d8cfb6efeb536d983bf2e05b04a
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2025-12-15 23:56:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 09:15:57 +0900

    [ruby/rubygems] Allow bundle pristine to work for git gems in the same repo:

    - Fix https://github.com/ruby/rubygems/pull/9186
    - ### Problem

      Running `bundle pristine` in a Gemfile where there is many git gem
      pointing to the same repository will result in a error
      "Another git process seems to be running in this repository".

      ### Context

      This error is a regression since https://github.com/ruby/rubygems/commit/a555fd6ccd17
      where `bundle pristine` now runs in parallel which could lead
      to running simultaneous git operations in the same repository.

      ### Solution

      When Bundler pristine a git gem it does a `git reset --hard` without
      specifying a path.
      This means the whole repository will be reset. In this case, we can
      leverage that by just pristining one gem per unique git sources.
      This is also more efficient.

    https://github.com/ruby/rubygems/commit/710ba514a8

commit 98cac1a75d9d9b7ff4cfd5b5d0fd99c1b5f17631
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-16 09:10:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-16 09:10:04 +0900

    Point people to redmine on ZJIT docs (#15499)

    Fix https://github.com/Shopify/ruby/issues/900

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit abefd3e8ff1853800d4df5b28388191b51d9ec37
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-11 05:11:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 07:48:40 +0900

    [ruby/psych] Check that Data members match exactly

    * Fixes https://github.com/ruby/psych/issues/760

    https://github.com/ruby/psych/commit/952008c898

commit b3f0fb56187dd9711fac0baae81a3f1ed0b5714a
  Author:     nick evans <nick@rubinick.dev>
  AuthorDate: 2025-12-12 05:25:59 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 07:48:40 +0900

    [ruby/psych] Replace C extension with Data#initialize bind_call

    https://github.com/ruby/psych/commit/6a826693ba

commit cfd41cbf0338a28638ed54edb0de13539b159dfb
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-16 06:28:41 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-16 07:28:35 +0900

    [DOC] Harmonize #-@ methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15570

commit acbf55f4e6658f94e49f28b4df21ab0c29683c4b
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-16 05:35:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-16 07:27:54 +0900

    [DOC] Harmonize #- methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15567

commit 7fbf321d23f3cc20988c80fae25ce131a5d1b231
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-16 05:20:25 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-16 07:27:24 +0900

    [DOC] Harmonize #** methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15566

commit 98ab418fed61079f8ef7e229ea1b41957ec5722b
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-16 07:07:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-16 07:07:15 +0900

    Revert "Fix Socket.tcp cleanup after Thread#kill (#15131)" (#15565)

    This reverts commit 3038286a4bf7832f1c42c8cc9774ee6ff19876fc.

    The following CI failure scared me:
    https://github.com/ruby/ruby/actions/runs/20241051861/job/58108997049

    ```
      1) Timeout:
      TestResolvDNS#test_multiple_servers_with_timeout_and_truncated_tcp_fallback
    ```

    Since it could be related, I'm reverting this for now.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit adf676c530b5da2822aa3b03ee43e5507111a0b2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-16 02:14:54 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 02:15:25 +0900

    [ruby/erb] Version 6.0.1

    https://github.com/ruby/erb/commit/bbde68fcd5

commit fdd8bdea8174835a5d83f561add9212e64f74cc0
  Author:     Daisuke Aritomo <di.aritomo@gmail.com>
  AuthorDate: 2025-12-16 02:14:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-16 02:14:36 +0900

    [ruby/erb] Freeze ERB::Compiler::TrimScanner::ERB_STAG
    (https://github.com/ruby/erb/pull/100)

    For Ractor compatibility.

    https://github.com/ruby/erb/commit/43f0876595

commit 9581d6c8988f9b54637b9872c42c79d16ff9fcb3
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-16 01:52:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-16 01:52:35 +0900

    ZJIT: Add iongraph-generating Ruby script (#15466)

    Run like so:

        $ ../tool/zjit_iongraph.rb ../build-dev/miniruby --zjit-call-threshold=2 tmp/ghbug.rb
        false
        false
        tmp/ghbug.rb:3:in 'Object#doit': this shouldnt ever be nil (RuntimeError)
                from tmp/ghbug.rb:10:in '<main>'
        W, [2025-12-09T11:00:32.070382 #67400]  WARN -- : Command failed with exit status 1
        zjit_iongraph_67405.html
        $

    Then open zjit_iongraph_67405.html with your browser.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 3038286a4bf7832f1c42c8cc9774ee6ff19876fc
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-16 01:48:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-16 01:48:34 +0900

    Fix Socket.tcp cleanup after Thread#kill (#15131)

    Socket.tcp launches ruby threads to resolve hostnames, and those threads
    communicate through a queue implemented with `IO.pipe`. When the thread
    that called `Socket.tcp` is killed, the resolver threads still try to
    communicate through the pipe even though it may be closed. The method
    `Socket.tcp_with_fast_fallback` tries to deal with this by killing the
    threads in an ensure block, and then closing the pipe. However, calling
    `Thread#kill` is not a blocking operation, it only sets a flag on the
    thread telling it to raise during the next interrupt. The thread needs
    to be joined to ensure it is terminated. The following script
    demonstrates the issue:

    ```ruby
    require "socket"

    ts = []
    5.times do
      ts << Thread.new do
        loop do
          1_000.times do |i|
            puts "#{i}"
            t = Thread.new do
              Socket.tcp("ruby-lang.org", 80)
            end
            sleep 0.001
            t.kill
          end
        end
      end
    end
    ts.each(&:join)
    ```

    output:
    ```
    /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1019:in 'IO#write': closed stream (IOError)
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1019:in 'IO#putc'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1019:in 'block in Socket::HostnameResolutionResult#add'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1017:in 'Thread::Mutex#synchronize'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1017:in 'Socket::HostnameResolutionResult#add'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:980:in 'Socket.resolve_hostname'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:719:in 'block (2 levels) in Socket.tcp_with_fast_fallback'
    /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1019:in 'IO#write': closed stream (IOError)
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1019:in 'IO#putc'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1019:in 'block in Socket::HostnameResolutionResult#add'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1017:in 'Thread::Mutex#synchronize'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:1017:in 'Socket::HostnameResolutionResult#add'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:978:in 'Socket.resolve_hostname'
            from /Users/luke/workspace/ruby-dev/ruby-build-debug/.ext/common/socket.rb:719:in 'block (2 levels) in Socket.tcp_with_fast_fallback'
    ```

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 6b63b0cbeb33c8606f147b0293e9b8ed8c34a0e5
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-12-16 00:07:54 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-12-16 01:28:11 +0900

    [DOC] Update Set#inspect description in NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15560

commit bb0e42c5e706f238dce40abb9cf5322e4a8a73cb
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-15 22:36:53 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-12-16 00:52:43 +0900

    Define Array#detect as an alias for Array#find

    Otherwise Array#detect is Enumerable#detect while Array#find uses a
    different more performant implementation.

    [Feature #21678]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15558

commit ac946e076c0136b070c84f66c8b018f8ab6b2223
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-15 22:43:17 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 22:43:53 +0900

    [ruby/prism] Unreference before destroying in call node in pattern

    https://github.com/ruby/prism/commit/609c80c91e

commit eceab2f44c631ceda13656728ae23b0750941001
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-15 10:39:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 20:38:29 +0900

    [ruby/prism] Escape error location is incorrect for some regex

    When you have a regular expression that has a named capture that
    has an escape sequence in the named capture, and that escape
    sequence is a unicode escape sequence with an invalid surrogate
    pair, the error was attached to the owned string as opposed to a
    location on the shared source.

    https://github.com/ruby/prism/commit/793a7a6a0a

commit bbc10ed0cdcd2fe9d7d09a9dcc5f036bc4425aef
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-15 20:10:49 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-15 20:11:46 +0900

    Add NEWS entry for Array#rfind and Array#find

commit f0793731853c0e130f798e9dc5c736b2fa1b72b7
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-14 19:10:04 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 18:50:30 +0900

    [ruby/openssl] Ruby/OpenSSL 4.0.0

    https://github.com/ruby/openssl/commit/5af1edab18

commit f06eb75646e7a8d17d9c41988207a2a29a3b006c
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-04-09 04:01:58 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 18:09:49 +0900

    [ruby/openssl] ossl.c: improve docs for constants and methods under ::OpenSSL

    https://github.com/ruby/openssl/commit/b0de8ba9bd

commit ee6ba41bfdc82110468598467cd10ce850b44f0c
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-14 19:55:28 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 18:09:49 +0900

    [ruby/openssl] Freeze more constants for Ractor compatibility

    https://github.com/ruby/openssl/commit/695126f582

commit 5a4faaaeb198b8cede59f323c7b6ed47e029c6db
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 22:40:45 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-15 16:05:21 +0900

    Merge `root_box_data` into `root_box`

    * Make invariant `root_box` an array consist of only `root_box_data`.
    * Remove the unnecessary initializer list that is just overwritten in
      `initialize_root_box()` and missing `classext_cow_classes`.
    * Shrink the scope using another local `root_box`.
    * Make the data type constants static.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15544

commit 700487ce21f0991fb5d4042707d12b2966670f1e
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-13 17:30:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 15:08:39 +0900

    [ruby/net-http] Refactor HTTPS tests

    This contains various improvements in tests for openssl integration:

      - Remove DHE parameters from test servers. OpenSSL is almost always
        compiled with ECC support nowadays and will prefer ECDHE over DHE.
      - Remove an outdated omission for a bug in OpenSSL 1.1.0h released in
        2018. None of our CI systems use this specific OpenSSL version.
      - Use top-level return to skip tests if openssl is unavailable.
      - Refactor tests for Net::HTTP#verify_callback.

    https://github.com/ruby/net-http/commit/35c1745a26

commit 1e76b1f8b29e8824832170d0a7cedcac711f99c4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-15 07:00:20 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-15 11:01:15 +0900

    [DOC] Remove doc/reline

    Reline has been moved to a bundled gem, so we don't need the docs anymore.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15548

commit 58940377e6f27f39d5c3baa0faa15655fa873f2c
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2025-11-26 04:17:03 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 10:15:06 +0900

    [ruby/rubygems] Write gem files atomically

    This change updates `write_binary` to use a new class,
    `AtomicFileWriter.open` to write the gem's files. This implementation
    is borrowed from Active Support's [`atomic_write`](https://github.com/rails/rails/blob/main/activesupport/lib/active_support/core_ext/file/atomic.rb).

    Atomic write will write the files to a temporary file and then once
    created, sets permissions and renames the file. If the file is corrupted
    - ie on failed download, an error occurs, or for some other reason, the
    real file will not be created. The changes made here make `verify_gz`
    obsolete, we don't need to verify it if we have successfully created the
    file atomically. If it exists, it is not corrupt. If it is corrupt, the
    file won't exist on disk.

    While writing tests for this functionality I replaced the
    `RemoteFetcher` stub with `FakeFetcher` except for where we really do
    need to overwrite the `RemoteFetcher`. The new test implementation is much
    clearer on what it's trying to accomplish versus the prior test
    implementation.

    https://github.com/ruby/rubygems/commit/0cd4b54291

commit e7cf07ba3e6758e3e6d34754422505c75fdf9c80
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-15 07:28:41 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-15 07:35:26 +0900

    [DOC] Fix link in MakeMakefile

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15549

commit 490a03bad9d3c18f66ae004055145db34d8ba599
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-12-15 02:26:42 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 06:11:21 +0900

    [ruby/prism] Fix `sexp_processor` gem reference

    It's https://rubygems.org/gems/sexp_processor, not https://rubygems.org/gems/sexp

    https://github.com/ruby/prism/commit/b8a00a5f15

commit 3e5c4ebe4bab556af2dd5d1ea83fa6d16ac0578b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-15 03:32:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-15 03:37:36 +0900

    [DOC] Fix backticks in Numeric#ceil

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15546

commit cd27337d0b2141757d19d00e8f6bb86723b843e9
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-15 03:31:54 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-15 03:37:36 +0900

    [DOC] Fix backticks in Numeric#floor

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15546

commit 529b49144eaac5eb8deb5036e459bec9f7940175
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-15 01:59:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 02:14:16 +0900

    [ruby/prism] Only set location end when it is larger

    https://github.com/ruby/prism/commit/65595d6c2c

commit ca08351546602cc55f67739fb5c8f616ce8aa94e
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-15 01:48:23 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 02:14:02 +0900

    [ruby/prism] Unreference the block node before destroying it

    https://github.com/ruby/prism/commit/fc150b1588

commit 4a84fa1b39e1bcd8c62b2b5225535dabcdcfdac4
  Author:     Ryan Davis <ryand-github@zenspider.com>
  AuthorDate: 2025-12-13 06:08:53 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-15 01:42:51 +0900

    [ruby/prism] Define RubyParser::SyntaxError directly and drop require for ruby_parser.

    Had to add a require of sexp since that came in indirectly via ruby_parser.

    https://github.com/ruby/prism/commit/df677c324f

commit 674c3d73e0f92d730bd2e544be344585a638ab37
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-14 19:33:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-14 19:46:27 +0900

    [ruby/openssl] pkcs7: raise OpenSSL::PKCS7::PKCS7Error in #initialize

    When d2i_PKCS7_bio() and PEM_read_bio_PKCS7() fail to decode the input,
    OpenSSL::PKCS7.new currently raises ArgumentError. The usual practice
    in ruby/openssl where an error originates from the underlying OpenSSL
    library is to raise OpenSSL::OpenSSLError.

    Raise OpenSSL::PKCS7::PKCS7Error instead for consistency with
    OpenSSL::PKCS7.read_smime and all other existing #initialize methods
    that handle DER/PEM-encoded inputs.

    https://github.com/ruby/openssl/commit/67a608ce53

commit 7969b654181af13f547afb88834f017694881353
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-01-30 02:47:18 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-14 19:46:13 +0900

    [ruby/openssl] x509cert: update doc for OpenSSL::X509::Certificate#==

    Mention the underlying OpenSSL function. Add a note about the unreliable
    comparison when called on an incomplete object.

    Fixes https://github.com/ruby/openssl/issues/844

    https://github.com/ruby/openssl/commit/736af5b3c7

commit 9e22037eb50d7abe6385901c9b029347fd383305
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 11:58:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-14 11:59:10 +0900

    [ruby/io-console] bump up to 0.8.2

    https://github.com/ruby/io-console/commit/fbc7e1f31f

commit f6ef4efaa46cdd5a3cd4aa6e3918f5eec9358557
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-10 22:13:36 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-14 11:45:48 +0900

    ZJIT: Add a test for `--zjit-stats=<path>` option

    Fix up [ruby/ruby#15414](https://github.com/ruby/ruby/pull/15414), 29c29c2b7e972359ab83038c5dc27a7e53ae65c7

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15477

commit 3a4d534b5bf68c783aaea34d3f9e33bc96f49a85
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-10 22:04:43 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-14 11:45:48 +0900

    ZJIT: Fix tests about `--zjit-stats-quiet` option

    The `--zjit-stats-quiet` and `--zjit-stats=quiet` options differ.
    The latter option, `=quiet`, does print stats to the file "quiet", but
    does not suppress output like yjit option `--yjit-stats=quiet`.

    Fix up [ruby/ruby#15414](https://github.com/ruby/ruby/pull/15414), 29c29c2b7e972359ab83038c5dc27a7e53ae65c7

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15477

commit c26057ebafb23b063190d31d5b4d19a0e0a1306c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 00:41:02 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-14 11:11:52 +0900

    [Bug #21779] Do not export InitVM functions

    Fix ruby/io-console#105.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15539

commit bc2a8a002a6c41fc1b28e02e15e2fb2b72d1b66e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 00:32:50 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-14 11:11:27 +0900

    [Bug #21779] Uniquify `InitVM` functions as well as `Init`

    Avoid possible name conflict when `--with-static-linked-ext`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15539

commit 01db5d71a851ae79ed501eb64c1491b072d44f2c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 00:31:53 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-14 10:57:42 +0900

    Removed duplicate code

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15539

commit c198436f08801adb6e3f3dfdf50d47f4ebf5eab0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 10:09:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-14 10:09:41 +0900

    Run omnibus compilations without git

commit 0159a98bc18641b3aa644e50b3d1081b1e447cf1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 05:30:53 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-14 05:30:53 +0900

    [Feature #20925] Skip infinite loop test

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15541

commit b423204cb3851d1ad22d76578f7b516f1543c0dc
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-14 01:15:20 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-14 05:09:05 +0900

    Fix documentation of RB_PASS_CALLED_KEYWORDS in C API

commit e8d32dddc04b34e2454b1c37b271bc242dddb06e
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-04 23:15:57 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-14 01:57:53 +0900

    [ruby/openssl] ossl.c: implement OpenSSL::OpenSSLError#detailed_message

    An OpenSSL function sometimes puts more than one error entry into the
    thread-local OpenSSL error queue. Currently, we use the highest-level
    entry for generating the exception message and discard the rest.

    Let ossl_make_error() capture all current OpenSSL error queue contents
    into OpenSSL::OpenSSLError#errors and extend
    OpenSSL::OpenSSLError#detailed_message to include the information.

    An example:

        $ ruby -Ilib -ropenssl -e'OpenSSL::X509::ExtensionFactory.new.create_ext("a", "b")'
        -e:1:in 'OpenSSL::X509::ExtensionFactory#create_ext': a = b: error in extension (name=a, value=b) (OpenSSL::X509::ExtensionError)
        OpenSSL error queue reported 2 errors:
        error:11000082:X509 V3 routines:do_ext_nconf:unknown extension name
        error:11000080:X509 V3 routines:X509V3_EXT_nconf_int:error in extension (name=a, value=b)
                from -e:1:in '<main>'

    https://github.com/ruby/openssl/commit/d28f7a9a13

commit 6513cf9058978e06eb3433fa33c8f70bd1100352
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-14 00:30:34 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-14 00:43:14 +0900

    Export `GIT`

    Propagate the value given with `--with-git` configure option to
    tool/lib/vcs.rb.

commit 79a6ec74831cc47d022b86dfabe3c774eaaf91ca
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2025-11-20 23:36:21 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2025-12-13 23:33:09 +0900

    Enumerator.produce accepts an optional `size` keyword argument

    When not specified, the size is unknown (`nil`).  Previously, the size was always `Float::INFINITY` and not specifiable.

    [Feature #21701]

commit 0561eb94250f5f856ff2594f86f897295b680582
  Author:     Steven Johnstone <steven.james.johnstone@gmail.com>
  AuthorDate: 2025-11-19 18:30:57 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-13 23:29:47 +0900

    [ruby/prism] Prevent an infinite loop parsing a capture name

    Fixes https://github.com/ruby/prism/pull/3729.

    https://github.com/ruby/prism/commit/6e5347803c

commit 3a4ad76f9d63cf4773814d0a76e2e033207193fd
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-12-08 23:23:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-13 21:37:51 +0900

    [ruby/io-console] console_cursor_pos respects scroll position on windows

    https://github.com/ruby/io-console/commit/ae33785820

commit c8fd840599cbd312094247e772dc509656347c0d
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-12-08 21:10:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-13 21:37:51 +0900

    [ruby/io-console] console_goto respects scroll position on windows

    https://github.com/ruby/io-console/commit/d2a6c69697

commit 2912825829d8280cfc7862adaceb8ccf680dad69
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-12-08 21:10:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-13 21:37:51 +0900

    [ruby/io-console] avoid jumping scroll position when winsize changed

    On windows, IO.console.winsize= now respects the current view area and screen buffer size.

    https://github.com/ruby/io-console/commit/817aa65ea3

commit 9dbbdcc33fb8cafb0f85b3442d8be3d030acd711
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-13 20:31:49 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-13 20:34:11 +0900

    [ruby/io-console] Remove useless rb_check_arity() call

    https://github.com/ruby/io-console/commit/df444b93f1

commit 71dd272506a31f28d216f26b0568028ed600f6ed
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2025-12-13 13:52:13 +0900
  Commit:     Shugo Maeda <shugo@ruby-lang.org>
  CommitDate: 2025-12-13 13:52:13 +0900

    Remove useless rb_check_arity() calls

commit e1f5e61d6b1b9e937a58afcae644da0917f6dd49
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-13 08:00:18 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-13 11:23:24 +0900

    YJIT: Fix panic from overly loose filtering in identity method inlining

    Credits to @rwstauner for noticing this issue in GH-15533.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15534

commit 6ed5574b19ff2692aff0e3b6fbe2d69d3a202618
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-13 10:27:01 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-13 10:27:23 +0900

    Revert "ZJIT: Exclude failing ruby-bench benchmarks (#15479)"

    This reverts commit 1eb10ca3cb6cff98bb8c0946ed905921586c7d52.

    This should have been fixed by https://github.com/ruby/ruby/pull/15536.

commit eb7acd75e7ae28ef1a22a7cbf5a50f99667aa8a6
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-12-13 10:00:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-13 10:00:17 +0900

    ZJIT: Nil-fill locals in direct send (#15536)

    Avoid garbage reads from locals in eval.
    Before the fix the test fails with

        <"[\"x\", \"x\", \"x\", \"x\"]"> expected but was
        <"[\"x\", \"x\", \"x\", \"x286326928\"]">.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 8f81d2b5c3d7e41a116b3b81a628b998d8e283be
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-12-13 06:35:41 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-13 08:55:18 +0900

    ZJIT: Don't inline non-parameter locals

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15533

commit 2f151e76b5dc578026706b31f054d5caf5374b05
  Author:     Aiden Fox Ivey <aiden@aidenfoxivey.com>
  AuthorDate: 2025-12-13 08:29:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-13 08:29:02 +0900

    ZJIT: Allow ccalls above 7 arguments (#15312)

    ZJIT: Add stack support for CCalls

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 176e384bcffd9d3de5ca4b9e56781b3c2b7bdfdd
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-12 08:56:38 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-13 07:03:37 +0900

    Cache filesystem_encindex

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15515

commit e7a38b32e0516e6b7d74f6cd55480cb453486691
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-11 03:20:02 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-13 06:53:06 +0900

    Store Encoding#name as an attribute

    When debugging the fstring table, I found "UTF-8" to be the most common
    interned strings in many benchmarks.

    We have a fixed, limited number of these strings, so we might as well permanently
    cache their fstrings.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15489

commit 2884f53519c4b86072d5fc3b41a71cee697af8ba
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-13 03:42:00 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-13 05:29:04 +0900

    YJIT: Add missing local variable type update for fallback setlocal blocks

    Previously, the chain_depth>0 version of setlocal blocks did not
    update the type of the local variable in the context. This can leave
    the context with stale type information and trigger panics like in
    [Bug #21772] or lead to miscompilation.

    To trigger the issue, YJIT needs to see the same ISEQ before and after
    environment escape and have tracked type info before the escape. To
    trigger in ISEQs that do not send with a block, it probably requires
    Kernel#binding or the use of include/ruby/debug.h APIs.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15532

commit 3add3db797c4216423fdaa4bef6e2ee3c7630303
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-13 04:47:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-13 04:47:43 +0900

    Fewer calls to `GET_EC()` and `GET_THREAD()` (#15506)

    The changes are to `io.c` and `thread.c`.
    I changed the API of 2 exported thread functions from `internal/thread.h` that
    didn't look like they had any use in C extensions:

    * rb_thread_wait_for_single_fd
    * rb_thread_io_wait

    I didn't change the following exported internal function because it's
    used in C extensions:

    * rb_thread_fd_select

    I added a comment to note that this function, although internal, is used
    in C extensions.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 5903ed7ba9ca60546aa0dd97e92b3d381b7918d3
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-12 00:46:14 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-13 04:27:37 +0900

    Prevent ifunc procs from being made shareable

    [Bug #21775]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15503

commit 7909ce2a839ba1c3e134239189e6aa2de3b6b630
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-13 04:24:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-13 04:24:40 +0900

    move th->event_serial to rb_thread_sched_item (#15500)

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 6147b695870ce82ee3ad5305ce095b63889b8d9d
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-11-15 01:31:23 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2025-12-13 03:35:30 +0900

    Array#rfind

    Implement Array#rfind, which is the same as find except from the
    other side of the Array. Also implemented Array#find (as opposed to
    the generic one on Enumerable because it is significantly faster
    and to keep the implementations together.

    [Feature #21678]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15189

commit 4f900e3ce9cefa76bc2c94e0e591acd51bf0e638
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2025-12-13 02:42:40 +0900
  Commit:     Stan Lo <stan001212@gmail.com>
  CommitDate: 2025-12-13 03:26:31 +0900

    ZJIT: Only optimize `[]` and `[]=` for exact Hash, not Hash subclasses

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15505

commit 309d6ef9c3792d1116809620a01240c7b8f4406e
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2025-12-12 06:23:37 +0900
  Commit:     Stan Lo <stan001212@gmail.com>
  CommitDate: 2025-12-13 03:26:31 +0900

    ZJIT: Inline `Hash#[]=`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15505

commit 3a0596b9a51121ebb7d3db06c438bf4182507c2a
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-13 03:14:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-13 03:14:00 +0900

    ZJIT: Add Shape type to HIR (#15528)

    It's just a nicety (they fit fine as CUInt32) but this makes printing
    look nicer in real execution and also in tests (helps with #15489).

    Co-authored-by: Randy Stauner <randy@r4s6.net>

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit bb4a6f39519c101b6bdc847d11cad55f19e62e9a
  Author:     Ryan Davis <ryand-github@zenspider.com>
  AuthorDate: 2025-12-07 18:11:04 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-13 02:52:16 +0900

    [ruby/prism] Fixed Prism::Translation::RubyParser's comment processing

    Tests were failing in Flay under Prism.

    https://github.com/ruby/prism/commit/af9b3640a8

commit b8ba9cebb9472c125c946e36ea4455e7aae284a6
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2025-12-13 01:40:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-13 01:40:49 +0900

    Fix binding.implicit_parameters_get/defined segfault when wrong name string is passed (#15530)

  Notes:
    Merged-By: tompng <tomoyapenguin@gmail.com>

commit f939cf40ba46f3a8136495702793748fa30c12c3
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-12 22:54:31 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-12 23:24:50 +0900

    Update NEWS about `Binding#implicit_parameters`, etc.

    [Bug #21049]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15525

commit 04422384ddf57159321f7fb214c457a378f65837
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-12 16:52:26 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-12 23:24:50 +0900

    Add docs to Binding#numbered_parameters, etc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15525

commit 129d74c96b0b8f1b93704b34e66d2c18f4835e1b
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-12 16:43:25 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-12 23:24:50 +0900

    Binding#implicit_parameters, etc. support the implicit "it" parameter

    [Bug #21049]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15525

commit fa7cddc969f1eccbb377cfc752bbf82ee2887dde
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-12 14:53:17 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-12 23:24:50 +0900

    Add Binding#implicit_parameters, etc.

    This changeset introduces:

    * `Binding#implicit_parameters`
    * `Binding#implicit_parameter_get`
    * `Binding#implicit_parameter_defined?`

    [Bug #21049]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15525

commit d428d086c23219090d68eb2d027498c6ea999b89
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-12 18:14:50 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-12-12 18:46:06 +0900

    Simplify the code

    `thread_sched_to_waiting_common0` is no longer needed.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15527

commit e2fe0aae43fee4815c1fc0896a2f03de35bfd873
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-12-12 18:12:41 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-12 18:12:41 +0900

    Avoid race condition in `test_without_handle_interrupt_signal_works`. (#15504)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit ff831eb0572b2d8f794acca478ea77c7bfefbc61
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-12 17:10:04 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-12 18:08:05 +0900

    thead_sync.c: directly pass the execution context to yield

    Saves one more call to GET_EC()

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15526

commit 7e7a1db579dad504a26e42d5f3efa5b2968389af
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-12 16:55:45 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-12 18:07:39 +0900

    Define Thread::ConditionVariable in thread_sync.rb

    It's more consistent with Mutex, but also the `#wait` method
    benefits from receiving the execution context instead of having
    to call `GET_EC`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15524

commit 175a0d5f1ad545d5f722e959a766eeed52e29ca1
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-12 17:35:55 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 17:39:02 +0900

    [ruby/timeout] Restore original signal handler in test_timeout_in_trap_handler

    https://github.com/ruby/timeout/commit/4ae8631acf

commit d9cc7621f39130c7c678af9eb72f7a28b539be9f
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-12 15:55:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 15:55:08 +0900

    Update bundled gems list as of 2025-12-12

commit 5ef4f88d5e0cea9a36702f8165a4d47a11c2a703
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-12 15:01:27 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-12-12 15:32:03 +0900

    use `ractor_sched_lock`

    instead of using `rb_native_mutex_lock` directly.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15522

commit 1794cfe12fe61dedebadead542927f9fef4104eb
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-12 14:44:09 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-12 15:21:29 +0900

    Binding#local_variable_defined? raises a NameError for numbered params.

    [Bug #21776]

commit 5541c0d896d220923e795aa4f87ceb6237d53c4b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-12 13:04:09 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-12 14:24:03 +0900

    Win32: Make `rb_w32_osid` return Windows NT always

    Since support for Windows 9x was dropped over a decade ago.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15520

commit f939f0433ab53bc1a8d567e0b52a09a95ce78bfb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-12 12:54:24 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-12 14:24:03 +0900

    Win32: Deprecate Windows version info API

    `dwMajorVersion` alone has no meaning since Windows 7.  Use API in
    VersionHelper.h instead.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15520

commit 50e5c542cc0541fb38e52766d88d87bd8a96b072
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-12 12:39:59 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-12 14:24:03 +0900

    Win32: Remove the workaround for console reading bug

    It has been fixed at Windows 8, and we already have dropped the
    support Windows 8 and olders.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15520

commit 04494d9e4064a57accc8309da9b35754a3d24973
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2025-12-12 12:00:35 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2025-12-12 13:16:52 +0900

    `Binding#local_variable_defined?` must not handle numbered parameters

    [Bug #21776]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15519

commit be43ad37b7fe7dbeaec653c4ec3dfcf5999e2824
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 10:57:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 10:57:38 +0900

    release.yml: Fix tag conversion for Ruby 4.0

    and PREVIOUS_RELEASE_TAG for any .0 releases

commit 8fba4b0f6008b68845be89861ddb73190d53511e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 10:54:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 10:54:48 +0900

    tool/format-release: Fix a wrong method reference

commit ec4c46709b74ae11a1d90ad3b2e8c9c79ee4afee
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 10:43:46 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 10:50:29 +0900

    tool/format-release: Carve out the version format logic

    to share it with tool/releng/update-www-meta.rb and another place I'm
    going to modify next.

commit faac344d1698b3f6b7e2bd8afbca1b7fbc46b9df
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 10:45:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 10:45:14 +0900

    make-snapshot: Fix Psych::DisallowedClass with newer psych

    ```
    $ tool/format-release ../www.ruby-lang.org 4.0.0-preview2 .
    /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/class_loader.rb:99:in 'Psych::ClassLoader::Restricted#find': Tried to load unspecified class: Date (Psych::DisallowedClass)
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/class_loader.rb:28:in 'Psych::ClassLoader#load'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/class_loader.rb:40:in 'Psych::ClassLoader#date'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/scalar_scanner.rb:65:in 'Psych::ScalarScanner#tokenize'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:65:in 'Psych::Visitors::ToRuby#deserialize'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:129:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Scalar'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:346:in 'block in Psych::Visitors::ToRuby#revive_hash'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:344:in 'Array#each'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:344:in 'Enumerable#each_slice'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:344:in 'Psych::Visitors::ToRuby#revive_hash'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:168:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Mapping'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:339:in 'block in Psych::Visitors::ToRuby#register_empty'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:339:in 'Array#each'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:339:in 'Psych::Visitors::ToRuby#register_empty'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:147:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Sequence'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:319:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Document'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych.rb:336:in 'Psych.safe_load'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych.rb:371:in 'Psych.load'
            from tool/format-release:80:in 'Tarball.parse'
            from tool/format-release:269:in 'Object#main'
            from tool/format-release:272:in '<main>'
    ```

commit 3a76625915e57eb328d23ae5dd621d8bf45b30e0
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-12-12 10:28:11 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-12 10:28:11 +0900

    ZJIT: Don't specialize calls with kwsplat (#15513)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 1f0ca55750413603057fabef39550feb9e7fc3c8
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 09:59:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-12 09:59:26 +0900

    make-snapshot: Update the tag format for Ruby 4.0+ (#15514)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 06a6ad44f6faf35542e0bd1e15658340d449c2cf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 09:42:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 09:45:04 +0900

    make-snapshot: Remove an unnecessary variable

    This is a refactoring change, which should have no impact on behaviors.

    Now, if patchlevel is true, tag is empty. So `if patchlevel` always does
    nothing. Given that prerelease is false and tag is not nil, removing
    `if patchlevel` should have no impact.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15512

commit 6601640c68b02f0bf1ad58d9122e76c84b735f91
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 09:37:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 09:45:04 +0900

    make-snapshot: Branch if it's X.Y.Z or X.Y using when

    It just seems like a completely different input, so it makes more sense
    to me to have it as a separate case.

    Also, we don't need to support Ruby 2.0 or older.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15512

commit 0ecf68963571b70103f7fa35b7403585585d032c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 09:35:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 09:45:04 +0900

    make-snapshot: Make preview/rc match stricter

    to make it a bit more consistent with the other branch

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15512

commit 58f9aca0ccc51a1f9c02280438518c9be8047dbd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 09:33:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 09:45:04 +0900

    make-snapshot: Drop X.Y.Z-pN support

    We no longer make patchlevel releases.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15512

commit 12bf3a99d72f5f6f0a7633863e285029aa407c57
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 09:18:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 09:18:37 +0900

    update-www-meta.rb: Update the tag format for Ruby 4.0+

    Just copied format-release fixes in
    a973526c050fec044ffd7ceeba0ac8e8a1fed299 to this file.

commit aff0c6dad2486e939e7f6678c519314925dad866
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 08:52:46 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 08:52:46 +0900

    tool/merger.rb: Support the new format in remove_tag

commit 04299ca184daa836b143eabb7835540928076595
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-12 07:54:22 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-12 08:29:21 +0900

    monitor.c: skip GET_EC() on exit

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15510

commit a973526c050fec044ffd7ceeba0ac8e8a1fed299
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 07:41:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 07:49:17 +0900

    tool/format-release: Fix the tag format for Ruby 4.0+

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15508

commit 0564214a00450371527c7bd69fc13618e5f25f30
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 07:27:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-12 07:49:17 +0900

    tool/merger.rb: Update the tag format for Ruby 4.0+

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15508

commit 8210a117814662e5ad405d5824c5f1d100f450a5
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-12 06:05:16 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-12 07:25:57 +0900

    test_ractor.rb: old object while calling _id2ref

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15476

commit 07b2356a6ad314b9a7b2bb9fc0527b440f004faa
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-10 19:44:27 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-12 07:25:57 +0900

    Mutex: avoid repeated calls to `GET_EC`

    That call is surprisingly expensive, so trying doing it once
    in `#synchronize` and then passing the EC to lock and unlock
    saves quite a few cycles.

    Before:

    ```
    ruby 4.0.0dev (2025-12-10T09:30:18Z master c5608ab4d7) +YJIT +PRISM [arm64-darwin25]
    Warming up --------------------------------------
                   Mutex     1.888M i/100ms
                 Monitor     1.633M i/100ms
    Calculating -------------------------------------
                   Mutex     22.610M (± 0.2%) i/s   (44.23 ns/i) -    113.258M in   5.009097s
                 Monitor     19.148M (± 0.3%) i/s   (52.22 ns/i) -     96.366M in   5.032755s
    ```

    After:
    ```
    ruby 4.0.0dev (2025-12-10T10:40:07Z speedup-mutex 1c901cd4f8) +YJIT +PRISM [arm64-darwin25]
    Warming up --------------------------------------
                   Mutex     2.095M i/100ms
                 Monitor     1.578M i/100ms
    Calculating -------------------------------------
                   Mutex     24.456M (± 0.4%) i/s   (40.89 ns/i) -    123.584M in   5.053418s
                 Monitor     19.176M (± 0.1%) i/s   (52.15 ns/i) -     96.243M in   5.018977s
    ```

    Bench:

    ```
    require 'bundler/inline'

    gemfile do
      gem "benchmark-ips"
    end

    mutex = Mutex.new
    require "monitor"
    monitor = Monitor.new

    Benchmark.ips do |x|
      x.report("Mutex") { mutex.synchronize { } }
      x.report("Monitor") { monitor.synchronize { } }
    end
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15476

commit dc58d58a723cf56d2a59db52252b82755248b539
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-12-12 07:12:03 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 07:21:26 +0900

    [ruby/timeout] Fix failing timeout test

    ```
    Run options:
      "--ruby=./miniruby -I../ruby/lib -I. -I.ext/common  ../ruby/tool/runruby.rb --extout=.ext  -- --disable-gems"
      --excludes-dir=../ruby/test/.excludes
      --name=!/memory_leak/
      --seed=9843

    [ 1/31] TestTimeout#test_timeout_in_trap_handler = 0.00 s
    1) Error:
    TestTimeout#test_timeout_in_trap_handler:
    NoMethodError: undefined method 'kill' for nil
        /Users/luke/workspace/ruby-dev/ruby/test/test_timeout.rb:9:in 'TestTimeout#kill_timeout_thread'
        /Users/luke/workspace/ruby-dev/ruby/test/test_timeout.rb:424:in 'TestTimeout#test_timeout_in_trap_handler'

    Finished tests in 2.715032s, 11.4179 tests/s, 52.3014 assertions/s.
    31 tests, 142 assertions, 0 failures, 1 errors, 0 skips

    ruby -v: ruby 4.0.0dev (2025-12-11T21:56:23Z fix_timeout_test https://github.com/ruby/timeout/commit/1c5eacbf9a) +PRISM [arm64-darwin24]
    make: *** [yes-test-all] Error 1
    ```

    https://github.com/ruby/timeout/commit/e5bc1de901

commit 64062792c61d13d1eca9f637db3ed7da12a61154
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-12 06:12:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-12 06:12:00 +0900

    ZJIT: Check method visibility when optimizing sends (#15501)

    Fix https://github.com/Shopify/ruby/issues/874

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit fb80587f88e2cb1d52098fe967aed6c43d74a82e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-12 05:24:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 05:45:58 +0900

    [ruby/timeout] Add windows to CI matrix

    https://github.com/ruby/timeout/commit/c8d63ce3fe

commit f8f8ff61062080887ad26a36bd58b51e631eee80
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-11 17:06:54 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-12 05:45:56 +0900

    auto_request_review.yml: Update path for jit related docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15493

commit eb889e474d02f79565f5d8cf001d86bd8aeb737d
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-11 16:55:05 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-12 05:45:56 +0900

    ZJIT: s/checking possible to build ZJIT/checking prerequisites for ZJIT/

    Reads better to me:

    > checking prerequisites for ZJIT... yes

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15493

commit c092c294d4ef08135c5d63db00824b3ec27274d2
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-11 16:41:55 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-12 05:45:56 +0900

    ZJIT: [DOC] Mention build prerequisites

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15493

commit 832aac6c283c59a1bcd3dc81badd380d0fc4dc2f
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-11 16:15:11 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-12 05:45:56 +0900

    Tune AS_CASE indentation style and remove `[*]` for default case

    There are many indentation styles for AS_CASE in this file but no one
    uses `[*]` for the default case.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15493

commit 1b7c8b7993c596cba7251dad16ff8e7234fd976f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-12 05:19:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 05:21:21 +0900

    [ruby/timeout] Skip signal test on windows

    Windows has no SIGUSR1.

    There might be another usable signal, but this is breaking ruby master
    so I just want a quick fix for now.

    https://github.com/ruby/timeout/commit/b19043e8d0

commit d02c97157476bbd9774f2bf6425a69166b99da1b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 03:57:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-12 03:57:06 +0900

    Stop bumping RUBY_PATCHLEVEL in release versions (#15502)

    [[Misc #21770]](https://bugs.ruby-lang.org/issues/21770)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 89e09e4daf1b27c94dbf326c8f5b0b5f864a6e72
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-06 19:16:59 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-12 02:53:18 +0900

    Add assumption to free_vm_weak_references

    Help the compiler know that we always get a heap object here.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15491

commit 32e6dc0f31b98cf17dd9ace46561d74a55966b20
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-06 16:31:33 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-12 02:53:10 +0900

    Speed up class allocator search

    This rewrites the class allocator search to be faster. Instead of using
    RCLASS_SUPER, which is now even slower due to Box, we can scan the
    superclasses list to find a class where the allocator is defined.

    This also disallows allocating from an ICLASS. Previously I believe that
    was only done for FrozenCore, and that was changed in
    e596cf6e93dbf121e197cccfec8a69902e00eda3.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15490

commit 459c377222e746a5e39756bf5d648d16893e831c
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-06 16:32:15 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-12 02:53:10 +0900

    Assume result from allocator will be valid

    This adds a fastpath in class_call_alloc_func to simply return if the
    class matches the one expected.

    I think we could probably just remove this check, or move it to the debug
    build.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15490

commit b5604833a37bf8cac132906fbf8297d6d4ae9976
  Author:     Gil Desmarais <gildesmarais@users.noreply.github.com>
  AuthorDate: 2025-12-12 01:38:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-12 01:38:39 +0900

    Fix Set#^ to not mutate its argument (#15296)

    * test(set): add test Set#xor does not mutate other_set

    * Fix Set#^ to not mutate its argument

  Notes:
    Merged-By: knu <knu@idaemons.org>

commit 3831a82d1916025f7dcdebcb9b66a0cd4fc98f00
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-12 00:12:35 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 00:32:48 +0900

    [ruby/json] Revert "Skip test failing with JRuby in CI"

    This reverts commit https://github.com/ruby/json/commit/b7e1734d9ca0.

    https://github.com/ruby/json/commit/5793694ee6

commit 4ab45e8f0cdf008db89c54c14a8214b915b80ab9
  Author:     kares <self@kares.org>
  AuthorDate: 2025-12-11 18:53:31 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-12 00:01:04 +0900

    [ruby/psych] bump snakeyaml-engine to 2.10 (jruby)

    https://github.com/ruby/psych/commit/506bf75ab2

commit 965ae7f386d7b403c4cc32d260beab4acce31856
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-11 23:58:23 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-11 23:58:23 +0900

    Fix typo in Fiber.[] docs

commit b49ff7cc700ffdba26fabaaf8167eee189797edf
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-11 22:16:49 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-11 22:38:35 +0900

    [ruby/timeout] Make Timeout.timeout work in a trap handler on CRuby

    * Fixes https://github.com/ruby/timeout/issues/17

    https://github.com/ruby/timeout/commit/1a499a8f96

commit 9865048a345a466b935226fa24515b32be664582
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-11 22:26:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-11 22:38:35 +0900

    [ruby/timeout] Encapsulate adding a timeout Request

    https://github.com/ruby/timeout/commit/cb2ba88fed

commit c678e1bdd3e43814814bb8ab44420de412f6235d
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-11 20:29:09 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-11 22:05:40 +0900

    [ruby/timeout] Revise Timeout.timeout docs and add a section about `ensure`

    https://github.com/ruby/timeout/commit/7cfa5a6778

commit 46d8e6d99321b764c4ce529ca1b0c39670193e67
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-11 19:20:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-11 22:05:39 +0900

    [ruby/timeout] Reset the interrupt mask when creating the Timeout thread

    * Add tests related to Thread.handle_interrupt
    * Fixes https://github.com/ruby/timeout/issues/41

    https://github.com/ruby/timeout/commit/a52720e82a

commit d6b40320b2cfecf9802e664a4869353d195fcc6d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-11 19:34:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-11 20:56:20 +0900

    Append found lib/<file> entries to spec.files to support out-of-place builds

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15497

commit 6b469b7e40f94f25b50463de2190d540d646e3f1
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-11 19:55:40 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-11 19:58:31 +0900

    [ruby/json] Release 2.18.0

    https://github.com/ruby/json/commit/1cdd2122d5

commit 6ad4e6a298e7b5d0f925aacecc5d375968ebde15
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-11 19:09:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-11 19:53:15 +0900

    [ruby/json] Add `allow_control_characters` parsing option

    While it's not allowed by the spec, some parsers like Oj do
    accept it, and it can be blocking a transition.

    Having this feature can help people migrate.

    https://github.com/ruby/json/commit/3459499cb3

commit 281a000d6669d3fbb1c0a2f940cbb9c7c01732e6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-03-31 01:09:22 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-11 19:20:12 +0900

    [Bug #19558] Allow ASCII range to mix with Unicode dump

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15488

commit dc41cf332613db24af512bc7e959fc9a17d85d59
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-11 18:42:07 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-11 18:42:07 +0900

    [Misc #21690] Sync parser_bits.h from internal/bits.h

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15496

commit c5b51bdd8c69ae038daf80cb227df854ca0110f1
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2025-12-02 11:03:02 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2025-12-11 18:35:39 +0900

    [Bug #21712] Allow `.()` call for command with block

    This commit allows codes like `a b do end.()` and `a b do end&.()`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15495

commit 278a93a1bb721427ab1a2fa8d68c6f916c39de1d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-11 18:18:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-11 18:18:13 +0900

    This change didn't fix the original issue.

    Revert "Use base: with Dir.glob for bundler.gemspec"

    This reverts commit 87f0701b6106569a8486c9623dc6b0b32438355c.

commit 240e7999de6f6293a577528972dbc220c6d2cc5a
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2025-12-11 17:57:49 +0900
  Commit:     Shugo Maeda <shugo@ruby-lang.org>
  CommitDate: 2025-12-11 18:00:32 +0900

    [DOC] Update NEWS for `*selectors` arguments added to `String#strip` etc.

commit 87f0701b6106569a8486c9623dc6b0b32438355c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-11 17:06:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-11 17:57:14 +0900

    Use base: with Dir.glob for bundler.gemspec

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15494

commit c76ba839b153805f0498229284fea1a809308dbc
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2025-12-11 17:34:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 17:34:57 +0900

    Allow String#strip etc. to take optional character selectors

    [Feature #21552]

    Co-Authored-By: Claude <noreply@anthropic.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15400

    Merged-By: shugo <shugo@ruby-lang.org>

commit 83e080705cc7aba4571b23e7034a3edd84cc26a6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-11 10:28:03 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-11 10:28:03 +0900

    Remove an excess closing bracket

commit c7d56e90d381f0bf115a5c76cbef9df6ae19f4c9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-11 09:07:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 09:07:39 +0900

    ZJIT: Re-compile ISEQs invalidated by PatchPoint (#15459)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 1c29fbeca00d4be63e3f537609b88a8f10115ae4
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-11 05:58:23 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-11 09:02:01 +0900

    GC_DEBUG_STRESS_TO_CLASS should only be for debug

    I believe this was accidentally left in as part of
    2beb3798bac52624c3170138f8ef65869f1da6c0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15485

commit 5828872ec4814a5a07f5f4c7686c543127619197
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-11 06:13:21 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-11 09:01:27 +0900

    Update Ractor warning message

    Although the Ractor API is still experimental and may change, and there
    may be some implementation issues, we should no longer say that there
    are many.

    Hopefully we can remove this warning entirely for Ruby 4.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15486

commit b208f46f48f88cf4d0b813edbfab07214d085e89
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-11 06:26:22 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-11 07:03:26 +0900

    ZJIT: Don't fold LoadField with negative offsets and use byte_add

    No point doing the manual size unit conversion for add. Sorry, no new
    tests since there is no way to generate a LoadField with a negative
    offset from ruby code AFAICT. Careful with the `as` casts.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15487

commit 029a48176cf9fd367d52d8c9f87cb9f77d425a43
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-09 12:25:05 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-11 06:35:00 +0900

    JITs: Drop cargo and use just rustc for release combo build

    So we don't expose builders to network flakiness which cannot be worked
    around using cargo's --offline flag.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15456

commit 121d0da02580693ac5f872578284e26e2668b577
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-09 12:30:22 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-11 06:35:00 +0900

    JITs: Move cargo-specific variables into conditional

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15456

commit 1bab216062e94e8856ddf3760806b189b4ac5b09
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-09 12:12:12 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-11 06:35:00 +0900

    ZJIT: For rustc build, remove cargo touch(1) workaround

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15456

commit b0ea9070d4f42f1844af7eac347ddfb9b4760439
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-09 12:09:38 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-11 06:35:00 +0900

    YJIT: For rustc build, remove cargo touch(1) workaround

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15456

commit 96c804de1f6a495c339f85069a648d37dadfbc80
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-09 12:08:04 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2025-12-11 06:35:00 +0900

    ZJIT: Remove unused includes from zjit.c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15456

commit c8909030974772b4f19742bac55875e32674d27f
  Author:     Tobias Lütke <tobi@shopify.com>
  AuthorDate: 2025-12-11 06:18:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 06:18:08 +0900

    ZJIT: Fold LoadField on frozen objects to constants (#15483)

    * ZJIT: Fold LoadField on frozen objects to constants

    When accessing instance variables from frozen objects via attr_reader/
    attr_accessor, fold the LoadField instruction to a constant at compile
    time. This enables further optimizations like constant propagation.

    - Add fold_getinstancevariable_frozen optimization in Function::optimize
    - Check if receiver type has a known ruby_object() that is frozen
    - Read the field value at compile time and replace with Const instruction
    - Add 10 unit tests covering various value types (fixnum, string, symbol,
      nil, true/false) and negative cases (unfrozen, dynamic receiver)

    * Run zjit-test-update

    * Add a test that we don't fold non-BasicObject

    * Small cleanups

    ---------

    Co-authored-by: Max Bernstein <ruby@bernsteinbear.com>
    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit ccfd31162a8455ac2502ebaf90873b966a866216
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-11 05:23:08 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-11 05:56:40 +0900

    Remove object_id in NEWOBJ tracepoint test

    Generating an object_id for any type other than T_OBJECT (and T_CLASS)
    will inevitably allocate an IMEMO/fields objects, which isn't supported
    in a NEWOBJ tracepoint.

    See: https://bugs.ruby-lang.org/issues/21710#note-23

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15484

commit 3640cfe5e0f3ed30f90ae622ef92e6c154213a09
  Author:     Alex Rocha <9896751+alexcrocha@users.noreply.github.com>
  AuthorDate: 2025-12-11 05:30:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 05:30:04 +0900

    ZJIT: Use inline format args (#15482)

  Notes:
    Merged-By: st0012 <stan001212@gmail.com>

commit 330ddccfee1c986add758384b31b0677935bfa3a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-11 03:10:54 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 03:10:54 +0900

    ubuntu.yml: Add a ruby-bench job without ZJIT (#15480)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 41ee65899a7a6c6abca9701957bc84f598d2491a
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-09 08:54:26 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-11 02:49:18 +0900

    Always treat encoding as TYPEDDATA

    Encodings are RTypedData, not the deprecated RData. Although the
    structures are compatible we should use the correct API.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15472

commit 1eb10ca3cb6cff98bb8c0946ed905921586c7d52
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-11 02:45:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 02:45:09 +0900

    ZJIT: Exclude failing ruby-bench benchmarks (#15479)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit ed18a212abe2d92feb441db2b6f084c0c77a65e4
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-11 01:08:55 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-11 01:08:55 +0900

    ZJIT: Check if shape is too complex before reading ivar by index (#15478)

    This fixes a crash when the new shape after a transition  is too complex;
    we need to check that it's not complex before trying to read by index.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 2b66fc763a6657c9a25719c5f70ae7b66abc2232
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-10 20:42:33 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-10 20:42:33 +0900

    Fix typos in comment of rb_current_execution_context()

commit 023c6d808a85bd8fb711ac3986972618037f12ad
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-10 18:54:18 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 19:14:39 +0900

    [ruby/json] Add a specific error for unescaped newlines

    It's the most likely control character so it's worth
    giving a better error message for it.

    https://github.com/ruby/json/commit/1da3fd9233

commit 6777d1012d24b4dd3585809030333ccfb1c46799
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-10 18:35:37 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-10 19:06:35 +0900

    Modernize Monitor TypedData

    Make it embedded and compaction aware.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15475

commit c5608ab4d79f409aaa469b4f4a20962a0ba4a688
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-03 23:35:03 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-10 18:30:18 +0900

    Monitor: avoid repeated calls to `rb_fiber_current()`

    That call is surprisingly expensive, so trying doing it once
    in `#synchronize` and then passing the fiber to enter and exit
    saves quite a few cycles.

commit e8a55274f202df1cfddc25aa14da34ba5a0e538d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 16:07:17 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 16:08:05 +0900

    [ruby/forwardable] v1.4.0

    https://github.com/ruby/forwardable/commit/0257b590c2

commit 14ff851185bb8ff399e98b74cc107302a4e08e18
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-11-24 16:48:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 16:05:06 +0900

    [ruby/forwardable] Simpler and faster check for the delegation fastpath

    Fix: https://github.com/ruby/forwardable/issues/35
    [Bug #21708]

    Trying to compile code to check if a method can use the delegation
    fastpath is a bit wasteful and cause `RUPYOPT=-d` to be full of
    misleading errors.

    It's simpler and faster to use a simple regexp to do the same check.

    https://github.com/ruby/forwardable/commit/de1fbd182e

commit 375025a3864fc944dc9f42909a6c5386c749d5fd
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-10 08:42:04 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-10 15:48:06 +0900

    Fix typo and shadowing

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15358

commit 462df17f8689e9ee87a45b88bb3283fd339e1247
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-09 19:17:38 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-10 15:48:06 +0900

    Attempt to reuse garbage slots in concurrent hash

    This removes all allocations from the find_or_insert loop, which
    requires us to start the search over after calling the provided create
    function.

    In exchange that allows us to assume that all concurrent threads insert
    will get the same view of the GC state, and so should all be attempting
    to clear and reuse a slot containing a garbage object.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15358

commit 81fbdff8fdf2ae7afb2fa19319ff7d40379521fe
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-11-25 09:50:29 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-10 15:48:06 +0900

    Use continuation bit in concurrent set

    This refactors the concurrent set to examine and reserve a slot via CAS
    with the hash, before then doing the same with the key.

    This allows us to use an extra bit from the hash as a "continuation bit"
    which marks whether we have ever probed past this key while inserting.
    When that bit isn't set on deletion we can clear the field instead of
    placing a tombstone.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15358

commit 8e87f201cf54b112642ed0421ddabd57336d672e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 15:42:31 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 15:43:06 +0900

    [ruby/optparse] v0.8.1

    https://github.com/ruby/optparse/commit/f2e31e81a5

commit 254653db8521618e08aaccaa63efdb42bd6ee84b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 15:38:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 15:39:36 +0900

    [ruby/win32-registry] v0.1.2

    https://github.com/ruby/win32-registry/commit/2a6ab00f67

commit 6ec5c5f1c8ac438752b53061d0cdd68a7e4ca8f9
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-11-15 22:48:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:18:21 +0900

    [ruby/stringio] [DOC] Doc for StringIO.size
    (https://github.com/ruby/stringio/pull/171)

    https://github.com/ruby/stringio/commit/95a111017a

commit b4a1f170583eb5553814261c311b183cbb390ba2
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-11-15 22:47:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:18:15 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#each_line
    (https://github.com/ruby/stringio/pull/165)

    Adds to "Position":  pos inside a character.

    Makes a couple of minor corrections.

    ---------

    https://github.com/ruby/stringio/commit/ff332abafa

    Co-authored-by: Sutou Kouhei <kou@cozmixng.org>

commit 5bc65db5550719a808858af361d5152931469c88
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 08:20:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:17:09 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#gets
    (https://github.com/ruby/stringio/pull/190)

    https://github.com/ruby/stringio/commit/77209fac20

commit f623fcc7d069cdfcaf25285c986ed995530a686f
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 08:18:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:16:53 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO.getbyte
    (https://github.com/ruby/stringio/pull/188)

    https://github.com/ruby/stringio/commit/66360ee5f1

commit 668fe01182df185c3592061e22087b6454132fec
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-06 01:07:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:16:39 +0900

    [ruby/stringio] [DOC] Fix link

    https://github.com/ruby/stringio/commit/e2d24ae8d7

commit 842f91aec09e419481af6358657e06973f2410c2
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 14:15:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:13:28 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#getc
    (https://github.com/ruby/stringio/pull/189)

    https://github.com/ruby/stringio/commit/e3d16d30ed

commit bbee62abbd26e3bf526dbbfddd17d72b81402a72
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 14:48:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-10 15:04:02 +0900

    We don't need to check the latest release of pathname

    Pathname is now embedded class of Ruby

commit 4523a905327d8438f845f5a75822225ccd041beb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 14:28:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 14:28:49 +0900

    [ruby/date] v3.5.1

    https://github.com/ruby/date/commit/1d0aadc295

commit 5f444cba4741b2ff0e1e95f4a179329b1ebc74a2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 14:21:59 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 14:22:25 +0900

    [ruby/ipaddr] v1.2.8

    https://github.com/ruby/ipaddr/commit/93ef50bc04

commit ec862b41dc9aaa2a22d80961b62417a347bc84ec
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-10 14:18:03 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-10 14:18:03 +0900

    ZJIT: Prohibit ZJIT support with USE_FLONUM=0 (#15471)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 814f23747b5fd7b0d5fb6cd8e45833ec39482858
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 14:11:45 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 14:12:32 +0900

    [ruby/resolv] v0.7.0

    https://github.com/ruby/resolv/commit/a0e89bbe48

commit df4fc0f7fcda6c552084ea0638c7185b4a98c939
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-10 14:07:11 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 14:08:04 +0900

    [ruby/psych] v5.3.0

    https://github.com/ruby/psych/commit/d8053b0d16

commit 3636277dc5837bcedcd5ef43d49423194064a676
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-10 12:09:50 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-10 12:09:50 +0900

    Add `NUM2PTR` and `PTR2NUM` macros

    These macros have been defined here and there, so collect them.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15470

commit 3bb97e7707a0be8c371cb9c704cb1e21062e1fc6
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-10 04:32:34 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-12-10 10:23:37 +0900

    `_RUBY_DEBUG_LOG` usable anywhere

    even if `USE_RUBY_DEBUG_LOG=0`.
    It becomes `fprintf(stderr, ...)`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15469

commit f9eb0d8da2cb570c6cf7754e4078ed0de266a52c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-10 09:22:09 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-10 09:22:09 +0900

    Use `ruby_version_is`

    As the markers for spec/mspec/tool/remove_old_guards.rb.

commit 29c29c2b7e972359ab83038c5dc27a7e53ae65c7
  Author:     Aiden Fox Ivey <aiden@aidenfoxivey.com>
  AuthorDate: 2025-12-10 08:14:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-10 08:14:49 +0900

    ZJIT: Add dump to file for --zjit-stats (#15414)

    * ZJIT: Add dump to file for --zjit-stats

    * ZJIT: Rename --zjit-stats=quiet to --zjit-stats-quiet

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit e436dba9fee4c75104212ad0fd16ab7f753985c4
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-11-23 12:58:43 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-12-10 07:35:50 +0900

    Use rb_error_frozen_object in rb_class_modify_check

    This provides information on the class of the frozen object. It also
    results in a much simpler implementation.

    Fixes [Bug #21374]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15303

commit 76fb0d244b95a23116bfe72bb2422395c3a76477
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-11-23 12:51:46 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-12-10 07:35:50 +0900

    Use actual class instead of singleton class in frozen error message

    With the following code:

    ```ruby
    object = []
    object.singleton_class
    object.freeze
    object.instance_variable_set(:@a, 42)
    ```

    The previous error message was:

    ```
    can't modify frozen #<Class:#<Array:0x00000631d1308f78>>: []
    ```

    With this change, the error message is:

    ```
    can't modify frozen Array: []
    ```

    Since we show the inspect value of the affected object, I think
    including the singleton class instead of the actual class if it
    exists makes the error message harder to understand.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15303

commit 1e7cf7b2bc1f9b356b2e980e1e18548618da6363
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-10-11 08:32:43 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-12-10 06:19:52 +0900

    Fix refinement modification of method visibility in superclass

    Previously, this didn't work correctly, resulting in a
    SystemStackError. This fixes the issue by finding the related
    superclass method entry, and updating the orig_me in the
    refinement method to point to the superclass method.

    Fixes [Bug #21446]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/14817

commit 6409715212d22699bd2751a363b050a5d8b94b83
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-12-03 10:34:36 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2025-12-10 05:44:50 +0900

    Fix allocationless anonymous splat keyword argument check

    Previously, if an argument splat and keywords are provided by
    the caller, it did not check whether the method/proc accepted
    keywords before avoiding the allocation. This is incorrect,
    because if the method/proc does not accept keywords, the
    keywords passed by the caller are added as a positional
    argument, so there must be an allocation to avoid mutating
    the positional splat argument.

    Add a check that if the caller passes keywords, the
    method/proc must accept keywords in order to optimize.
    If the caller passes a keyword splat, either the
    method/proc must accept keywords, or the keyword splat must
    be empty in order to optimize.

    If keywords are explicitly disallowed via `**nil`, the
    optimization should be skipped, because the array is mutated
    before the ArgumentError exception is raised.

    In addition to a test for the correct behavior, add an
    allocation test for a method that accepts an anonymous splat
    without keywords.

    Fixes [Bug #21757]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15383

commit bd0d08b6d20e4145e472578d47164fcce14c0abf
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-12-10 05:29:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-10 05:29:58 +0900

    ZJIT: Show send fallback reason in HIR dump (#15454)

    This adds comments to the hir dump output like this:

      v13:BasicObject = SendWithoutBlock v6, :test, v11 # SendFallbackReason: Complex argument passing

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 98390d9360b8b8c82f798f51567587882c4e5c00
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-10 01:39:15 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2025-12-10 02:08:00 +0900

    Don't declare `rbimpl_check_typeddata` as pure

    [Bug #21771]

    It may raise so it's incorrect and can lead to the compiler
    optimizing the call out.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15467

commit f0b288adf7b3550dc5be6a02316c5822ff47ca82
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-12-06 11:57:08 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2025-12-10 00:19:38 +0900

    ZJIT: Put keyword bits in callee frame rather than c_args

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15241

commit c42f4d80eabc6b9b4117253a2ba2ee0b9526f253
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-11-15 06:50:39 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2025-12-10 00:19:38 +0900

    ZJIT: Handle caller_kwarg in direct send when all keyword params are required

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15241

commit 76d845aa7a0fa07aa3e733528cbd7e48feccfd59
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-11-19 08:19:49 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2025-12-10 00:19:38 +0900

    ZJIT: Test additional arg passing scenarios

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15241

commit 7ecfb1b2324d9488d4bd94801ed8a694d3c1ee0b
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2025-12-08 21:41:02 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-10 00:04:41 +0900

    [ruby/resolv] use domain suffix from 'Domain' instead of 'NV Domain'

    'NV Domain' does not change results of `powershell -command Get-DnsClientGlobalSetting`.
    'Domain' do this.

    https://github.com/ruby/resolv/commit/d49e3d5b84

commit 1933f1291a788369b252be80b0d452716d35831a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-09 23:44:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-09 23:44:06 +0900

    [DOC] Clear one of known issues of Ruby Box

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15464

commit 1e6a479520cb13f927399c97d363558b3beeaea7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-03 10:41:39 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-09 23:41:50 +0900

    Box: relax the condition of clean up

    It is impossible to delete DLLs being loaded on Windows.  I guess that
    unnamed (no accessible path on the filesystem) files are not allowed
    essentially.  The only way is to relax the condition, such as no files
    are left after the process terminated, probably.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15107

commit 07e85e1dba3e15c714044660f731a90ce86c8c24
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-02 22:22:01 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-09 23:41:50 +0900

    Box: add a test case about deleting .so/.dll files

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15107

commit 573896a40ac25bd9febb2bbc0502b43ef36f9b9b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-08 11:05:17 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-09 23:41:50 +0900

    Box: remove copied extension files

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15107

commit e8568bbcf20fafcb82d8b537b99762528dfbdc3e
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-09 23:03:41 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-09 23:08:33 +0900

    [DOC] Update Ruby Box documents (known issues)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15463

commit cb9510f539e12f7c58bf2e74186c6a48b62fec3c
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2025-12-04 11:16:27 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2025-12-09 22:52:05 +0900

    ZJIT: Support opt_newarray_send with PACK_BUFFER

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15407

commit c8441e8db52fe260545b83ffbe5278aff242bd14
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2025-12-04 10:53:50 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2025-12-09 22:52:05 +0900

    ZJIT: Clean up opt_newarray_send

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15407

commit edca81a1bb72a9dc54a37766d2c80790dec13884
  Author:     Abrar Habib <86024593+dddictionary@users.noreply.github.com>
  AuthorDate: 2025-12-09 21:41:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-09 21:41:09 +0900

    ZJIT: Add codegen for FixnumDiv (#15452)

    Fixes https://github.com/Shopify/ruby/issues/902

    This pull request adds code generation for dividing fixnums.
    Testing confirms the normal case, flooring, and side-exiting on division by zero.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 5ae2bd240f0adea46358f0a95bc26276d9f0cc31
  Author:     Satoshi Tagomori <s-tagomori@sakura.ad.jp>
  AuthorDate: 2025-12-09 21:29:36 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-09 21:36:26 +0900

    [DOC] Add Ruby::Box on NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15462

commit 0da74e0aa0189b1d2ec9dadf7b580f9bcd6adee7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-09 13:51:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 21:09:53 +0900

    [ruby/rubygems] Bump Rubygems version to 4.0.1

    (cherry picked from commit https://github.com/ruby/rubygems/commit/f3e5ebf5afe7)

    https://github.com/ruby/rubygems/commit/583b0222ad

commit 875c4c7dfdf9f9271fde47d6616249724af4d014
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-09 13:51:04 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 21:09:52 +0900

    [ruby/rubygems] Bump Bundler version to 4.0.1

    (cherry picked from commit https://github.com/ruby/rubygems/commit/26c1db5a65a8)

    https://github.com/ruby/rubygems/commit/bbb5b767d0

commit 8d1eafa7a7289141338a6ace6570e6850e529347
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-12 00:37:27 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-09 20:50:35 +0900

    Remove duplicate path names in error message

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15430

commit ee6784f2899364f9bfd8d605b1bea7d78777a116
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-10-20 13:30:46 +0900
  Commit:     Satoshi Tagomori <tagomoris@gmail.com>
  CommitDate: 2025-12-09 20:50:35 +0900

    Refine `copy_ext_file`

    - Define the error constants.
    - Use system calls to copy files if available.
    - Simplify fallback copying.
    - Copy without stdio buffering.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15430

commit 99133a66f3e5c64c2c2f5dbca0d1be816254f636
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-08 21:11:55 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 19:37:15 +0900

    [ruby/net-http] Check whether TCPSocket#initialize supports open_timeout once and without exceptions

    * See discussion in https://github.com/ruby/net-http/pull/224
    * This check is known to work on at least CRuby, TruffleRuby and JRuby.
    * Exceptions show up with `ruby -d`/`$DEBUG == true` and would show for every Net::HTTP instance.

    https://github.com/ruby/net-http/commit/8c76f92779

commit 79c57d747f7d1e6253a6df7b624a9930cb8a523c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-09 17:22:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-09 17:48:57 +0900

    Fixed by `misspell -w -error -source=text`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15460

commit 25f277abe481b9109d59d28a2eee3f9998a9ad3a
  Author:     hi <hi@localhost>
  AuthorDate: 2025-12-05 23:56:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-12-09 16:45:38 +0900

    Fix typos in gc.c and gc.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15420

commit 59314911a13d10eab2afbca62081311d702a1373
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-09 00:18:42 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 11:43:51 +0900

    [ruby/prism] Nested heredoc with newline terminator

    When you have a heredoc interpolated into another heredoc where
    the inner heredoc is terminated by a newline, you need to avoid
    adding the newline character a second time.

    https://github.com/ruby/prism/commit/8eeb5f358b

commit 268cbb29c7f69ea5a6d45973091a6e5f5aa89403
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-09 00:07:39 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 11:43:33 +0900

    [ruby/prism] Fully handle unreferencing a block exit

    If a block exit has a further block exit in its subtree, we need to
    keep recursing.

    https://github.com/ruby/prism/commit/855d81a4a8

commit cbf39c3be5b71b7321cfba768417427e7c3bf4ad
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-08 22:37:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 11:43:24 +0900

    [ruby/prism] Fix up call target node when invalid

    When there is an invalid syntax tree, we need to make sure to fill
    in the required call operator location.

    https://github.com/ruby/prism/commit/937313d7f0

commit 71354a9879c5e68b215469ef1b17eeb1ba308ada
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-12-08 22:26:28 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 11:43:05 +0900

    [ruby/prism] Fix hash pattern location when missing nodes

    https://github.com/ruby/prism/commit/0ad30561e2

commit 12c16f9dedb38af8111809229495e28e8d37b569
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2025-12-09 01:39:34 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 11:01:59 +0900

    [ruby/rubygems] Fix Bundler removing executables after creating them

    When running a fresh `bundle install` with gems that contains
    executables, Bundler will generate binstubs but soon after will remove
    them. This is a regression introduced in https://github.com/ruby/rubygems/commit/573ffad3ea4a.

    This results in doing `bundle install && bundle exec foo` to raise an
    error saying `foo` couldn't be found.

    This issue only appears if `BUNDLE_CLEAN` is set.

    At the end of the installation process, when Bundler has installed
    gems and generated binstubs, it runs the cleanup.

    1. It [detects](https://github.com/ruby/rubygems/blob/4f8aa3b40cded3465bb2cd761e9ce7f8673b7fcb/bundler/lib/bundler/runtime.rb#L182) the executable for the current specs
    2. Any existing executables not detected is then removed https://github.com/ruby/rubygems/blob/4f8aa3b40cded3465bb2cd761e9ce7f8673b7fcb/bundler/lib/bundler/runtime.rb#L194.

    The issue being that 1. now returns an empty array where as it should
    return the executables of the gems from the current bundle.

    The problem is in https://github.com/ruby/rubygems/commit/573ffad3ea4a where we
    removed the `executables` method from the `EndpointSpecification`.
    When Bundler reads the lockfile, it creates a `EndpointSpecification`
    object for each spec. At this point, the EndpointSpecification doesn't
    know about the `executables` of a gem. Once Bundler fetches the
    `gemspec` from the remote, it swaps the the "spec" with the real one
    and from here knows what executables the gem has.

    Reintroduce the `executables` method and the `bindir` in the
    EndpointSpecification class. From what I'm seeing, the removal
    of those wasn't needed to resolve the issue where Bundler remembers
    CLI flags. This is probably an oversight.

    https://github.com/ruby/rubygems/commit/b47f6b0247

commit 19172d64ebe909f185e28b1d8368a8a920f94a8b
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-08 20:24:03 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 10:37:51 +0900

    [ruby/rubygems] Fix indentation of the info message for default_cli_command

    * It looked like:
                In a future version of Bundler, running `bundle` without argument will no longer run `bundle install`.
                Instead, the `cli_help` command will be displayed. Please use `bundle install` explicitly for scripts like CI/CD.
                You can use the future behavior now with `bundle config set default_cli_command cli_help --global`,
                or you can continue to use the current behavior with `bundle config set default_cli_command install --global`.
                This message will be removed after a default_cli_command value is set.
      Bundler version 4.0.0 (2025-12-08 commit https://github.com/ruby/rubygems/commit/9b4819ae18)
    * And now looks like:
      In a future version of Bundler, running `bundle` without argument will no longer run `bundle install`.
      Instead, the `cli_help` command will be displayed. Please use `bundle install` explicitly for scripts like CI/CD.
      You can use the future behavior now with `bundle config set default_cli_command cli_help --global`,
      or you can continue to use the current behavior with `bundle config set default_cli_command install --global`.
      This message will be removed after a default_cli_command value is set.

      Bundler version 4.0.0 (2025-12-08 commit https://github.com/ruby/rubygems/commit/9b4819ae18)

    https://github.com/ruby/rubygems/commit/979dada8f3

commit fab94ecd344b5804f9a1e6b38082049f37bacbd3
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-05 21:04:34 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 10:37:50 +0900

    [ruby/rubygems] Fix the config suggestion in the warning for `$ bundle`

    * `install_or_cli_help` does not exist for older Bundler like Bundler 2
      and so results in a confusing error on Bundler 2:
      ```
      $ bundle
      Could not find command "".
      ```
    * See https://github.com/ruby/rubygems/pull/9136/files#r2592366837
    * Merge the behavior of `install_or_cli_help` in `install`.

    https://github.com/ruby/rubygems/commit/9b4819ae18

commit 056997cbcdd38b062518fe54e311c964f8bfd98f
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2025-12-09 09:05:45 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2025-12-09 10:09:00 +0900

    Remove needless `ruby2_keywords` field from `struct rb_args_info`

    `ruby2_keywords` is set only to be `0` in parse.y.
    However `args->ruby2_keywords` is initialized with `0` by `MEMZERO`
    in `rb_node_args_new` function and `body->param.flags.ruby2_keywords`
    is initialized with `0` by `ZALLOC` in `rb_iseq_constant_body_alloc` function,
    so `args->ruby2_keywords` does nothing for `body->param.flags.ruby2_keywords`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15441

commit 576acb950232a8d979b94117050f577505d8a167
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2025-12-06 16:02:49 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2025-12-09 10:09:00 +0900

    Remove `FORWARD_ARGS_WITH_RUBY2_KEYWORDS` check

    Because `FORWARD_ARGS_WITH_RUBY2_KEYWORDS` definition was removed
    by 4f77d8d3289ece0e3537d9273a5c745120bff59a.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15441

commit de94f88c6820c94b69df3343c6050cdb8cc0610e
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-03 17:06:03 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-09 09:38:45 +0900

    Register internal tracepoints globally

    Internal tracepoints only make sense to run globally, and they already
    took completely different paths.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15396

commit 55668d748457e7d9db4db93c050e80afe2e9bb47
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-06 09:13:23 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-09 09:38:45 +0900

    Only globally clear the flag being cleared

    This solution is not quite correct because it doesn't solve multiple
    Ractors subscribing to the same event, but this will avoid unrelated
    events clobbering the flags for other events.

    This however will work corretly for subscribing to global ObjectSpace GC
    events.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15396

commit 007a70a15c2911845f83872b83d39eeca7f0f607
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-08 20:03:44 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-09 08:54:24 +0900

    Test that Ractor.make_shareable mutates the original Proc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15446

commit 4cb3a61b5ec7714f57a7f43409ccc74746e7df6e
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-08 19:47:03 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-09 08:54:24 +0900

    Fix Ractor test to not depend on the previous test

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15446

commit 39a3b88659a04729a7eec30bbc5ea804a565b9eb
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-08 19:42:12 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-09 08:54:24 +0900

    Fix some descriptions in bootstraptest/test_ractor.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15446

commit 09f8b8e3ad46683f1166b5dc1d5ef01cacfae3e4
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2025-12-08 19:40:32 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2025-12-09 08:54:24 +0900

    Test that Ractor.shareable_proc keeps the original Proc intact

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15446

commit ca8630b6363a706a43bfdb5a3359addcfb616d19
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-08 15:33:54 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 08:52:15 +0900

    [ruby/rubygems] Extract and generate only bundler bin files instead of full installation.

    https://github.com/ruby/rubygems/commit/a70e573973

commit 55ea3ec00f5166423cd7dcd67e220cd264a766f6
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-08 02:43:44 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-09 08:01:05 +0900

    Fix strict aliasing warning in rb_int128_to_numeric

    If we don't have uint128, then rb_int128_to_numeric emits a strict
    aliasing warning:

        numeric.c:3641:39: warning: dereferencing type-punned pointer will break strict-aliasing rules [-Wstrict-aliasing]
        3641 |         return rb_uint128_to_numeric(*(rb_uint128_t*)&n);
             |                                       ^~~~~~~~~~~~~~~~~

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15440

commit 66bda731901d4588c9df1a671022231ea0d03216
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2025-12-09 06:58:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-09 06:58:35 +0900

    Remove unused local variables in test/ruby/test_io_buffer.rb (#15451)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 90a9b64238eca659df9d59d35f6cf59fa3851119
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-05 09:13:59 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2025-12-09 04:48:20 +0900

    Use rb_current_ec_noinline in ractor_{lock,unlock}

    We're seeing an occasional crash on CI because this ends up inlined all
    the way into ractor_wait_receive. On llvm (possibly other compilers) the
    thread local address of ec ends up cached (not the value of ec, the
    address ec is read from). So if we are migrated to another native
    thread, that may be invalid.

    Using rb_current_ec_noinline avoids this problems. It would be good to
    adjust this code so that ec (or current ractor) is calculated once and
    then passed through to both lock and unlock.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15415

commit e61b79b384307ae3358c13d015be3550db7c0b53
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-08 14:02:08 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-09 02:16:45 +0900

    Fix a typo in the deprecation warning message

commit bd752290e743e3465286b3c656c8e31869f1c4fc
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-09 00:50:32 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-09 02:06:19 +0900

    [ruby/timeout] Revert "Exclude constantly-failing test on x86_64-darwin"

    This reverts commit https://github.com/ruby/timeout/commit/45816b1b2602.

    https://github.com/ruby/timeout/commit/b54f91e9dd

commit fd45496f919f202dd30a6a76e7e24fc07abbedc0
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2025-12-09 01:59:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-09 01:59:27 +0900

    Update ZJIT docs (#15449)

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 956f8d490cde0bb6941f21d263287bd3a141348c
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2025-12-09 01:36:45 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-09 01:36:45 +0900

    ZJIT: Avoid redundant SP save in codegen (#15448)

  Notes:
    Merged-By: st0012 <stan001212@gmail.com>

commit 66b2cc3dabbedca1331507f8b4f2b274d0a47570
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-08 18:29:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-08 20:28:52 +0900

    [ruby/resolv] Check the second RegGetValue type

    https://github.com/ruby/resolv/commit/3678de9e30

commit 27d60e29845cce3159856ef25d8be533ef402e3c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-08 17:59:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-08 20:28:52 +0900

    [ruby/resolv] Fix warnings on cygwin

    https://github.com/ruby/resolv/commit/075e76f997

commit 159430e8b6a2c6b5a5a9c926676082fcaef7535e
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-08 17:59:57 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-12-08 18:41:06 +0900

    ignore Thread creation error

    on resource limited environment.

    ```
    stderr output is not empty
       bootstraptest.test_ractor.rb_2446_1412.rb:23:in 'Ractor.new': can't create Thread: Cannot allocate memory (ThreadError)
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15445

commit ced333677fb97f2fc720dfb86213ea416b3ebcf4
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-08 17:47:07 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2025-12-08 18:21:37 +0900

    fix SEGV on clang-16/18

    Maybe because of TLS/coroutine problem, CI fails on clang-16/18

    ```
      1) Failure:
    TestTimeout#test_ractor [/tmp/ruby/src/trunk_clang_18/test/test_timeout.rb:288]:
    pid 307341 killed by SIGSEGV (signal 11) (core dumped)
    | /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:98: [BUG] Segmentation fault at 0x0000000000000030
    | ruby 4.0.0dev (2025-12-07T16:51:02Z master 4f900c35bc) +PRISM [x86_64-linux]
    |
    | -- Control frame information -----------------------------------------------
    | c:0006 p:---- s:0026 e:000025 l:y b:---- CFUNC  :sleep
    | c:0005 p:---- s:0023 e:000022 l:y b:---- CFUNC  :wait
    | c:0004 p:0020 s:0017 e:000016 l:n b:---- BLOCK  /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:98 [FINISH]
    | c:0003 p:---- s:0014 e:000013 l:y b:---- CFUNC  :synchronize
    | c:0002 p:0072 s:0010 e:000009 l:n b:---- BLOCK  /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:96 [FINISH]
    | c:0001 p:---- s:0003 e:000002 l:y b:---- DUMMY  [FINISH]
    |
    | -- Ruby level backtrace information ----------------------------------------
    | /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:96:in 'block in create_timeout_thread'
    | /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:96:in 'synchronize'
    | /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:98:in 'block (2 levels) in create_timeout_thread'
    | /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:98:in 'wait'
    | /tmp/ruby/src/trunk_clang_18/lib/timeout.rb:98:in 'sleep'
    |
    | -- Threading information ---------------------------------------------------
    | Total ractor count: 3
    | Ruby thread count for this ractor: 2
    |
    | -- Machine register context ------------------------------------------------
    |  RIP: 0x0000602b1e08a5b5 RBP: 0x000071c65facd130 RSP: 0x000071c6258842e0
    |  RAX: 0x0000000000000000 RBX: 0x000000006935f7c4 RCX: 0x0000000000000000
    |  RDX: 0x0000602b1e520c20 RDI: 0x000071c620012480 RSI: 0x000071c620012480
    |   R8: 0x0000000000000000  R9: 0x0000000000000000 R10: 0x0000000000000000
    |  R11: 0x0000000000000000 R12: 0x000071c65fa2f640 R13: 0x000071c65fb66e48
    |  R14: 0x0000000000000000 R15: 0xfdccaa3270000002 EFL: 0x0000000000010202
    |
    | -- C level backtrace information -------------------------------------------
    | /tmp/ruby/build/trunk_clang_18/ruby(rb_print_backtrace+0x14) [0x602b1e31a6ea] /tmp/ruby/src/trunk_clang_18/vm_dump.c:1105
    | /tmp/ruby/build/trunk_clang_18/ruby(rb_vm_bugreport) /tmp/ruby/src/trunk_clang_18/vm_dump.c:1450
    | /tmp/ruby/build/trunk_clang_18/ruby(rb_bug_for_fatal_signal+0x15c) [0x602b1e2d960c] /tmp/ruby/src/trunk_clang_18/error.c:1131
    | /tmp/ruby/build/trunk_clang_18/ruby(sigsegv+0x5a) [0x602b1e05528a] /tmp/ruby/src/trunk_clang_18/signal.c:948
    | /lib/x86_64-linux-gnu/libc.so.6(0x71c65fd46320) [0x71c65fd46320]
    | /tmp/ruby/build/trunk_clang_18/ruby(vm_check_ints_blocking+0x0) [0x602b1e08a5b5] /tmp/ruby/src/trunk_clang_18/vm_core.h:2097
    | /tmp/ruby/build/trunk_clang_18/ruby(rb_current_execution_context) /tmp/ruby/src/trunk_clang_18/thread_sync.c:617
    | /tmp/ruby/build/trunk_clang_18/ruby(rb_mutex_sleep) /tmp/ruby/src/trunk_clang_18/thread_sync.c:617
    ```

    This patch introduces workaround by acquiring EC before swithcing coroutine.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15444

commit 1de15815a8b85f02ba73d9f7c30322530b471b5f
  Author:     yoshoku <yoshoku@outlook.com>
  AuthorDate: 2025-12-04 09:04:11 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-08 16:03:32 +0900

    [ruby/rubygems] Fix native extension loading in newgem template for RHEL-based systems

    Add fallback to `require` when `require_relative` fails to load native
    extensions. This addresses an issue on RHEL-based Linux distributions
    where Ruby scripts and built native extension shared libraries are
    installed in separate directories.

    https://github.com/ruby/rubygems/commit/68599bd107

commit a82aa08fe0112aefd35e28dc5ca3f9ea9238ae17
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-08 12:04:11 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-08 12:11:58 +0900

    Make `ruby_reset_leap_second_info` internal

    It is exported only for the extension library to test, but the method
    is no longer used since 29e31e72fb5a14194a78ec974c4ba56c33ad8d45.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15442

commit 6a1f5b68cbd90031d849265b663986c5b8dd39dd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-08 11:57:24 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-08 12:11:58 +0900

    Make `ruby_reset_timezone` internal

    It is used only in hash.c, when `ENV['TZ']` is set.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15442

commit 4655b174d5fa71b69781c56701be63a02215b12f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-08 12:05:54 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-08 12:06:40 +0900

    [ruby/timeout] v0.5.0

    https://github.com/ruby/timeout/commit/837d5aac73

commit be882278f22444e7d27db091bbd5f8bf63e882c2
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-07 14:51:38 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-08 11:47:39 +0900

    Move RBIMPL_ATTR_DEPRECATED_* macros to the appropriate header file

    Move these macros from include/ruby/backward.h to
    include/ruby/internal/attr/deprecated.h, alongside the other similar
    macros.

    include/ruby/internal/intern/vm.h cannot currently use them because
    include/ruby/backward.h is included too late.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15435

commit f2eece71990fd79a5d7e24999f8df5c1121253c6
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2025-12-07 14:58:28 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2025-12-08 11:47:39 +0900

    Remove the internal-only attribute from ruby_reset_timezone()

    The #ifdef is currently not taken because include/ruby/backward.h is
    not included at this point. The attribute is unnecessary in an internal
    header, so remove it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15435

commit 4f900c35bc01e12b948703b9e4b4f5d0e803f073
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-08 00:24:08 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-08 01:51:02 +0900

    Output ivar length for T_OBJECT in obj_info

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15438

commit a4d142137332e449c2e037fa123a9d477d22093a
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2025-12-08 01:35:47 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-08 01:35:47 +0900

    [DOC] Update bundled gems list at 379d22ce8418448ade3d410e5c76dd

commit 379d22ce8418448ade3d410e5c76dd2ca0c7a8cf
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2025-12-08 01:35:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-08 01:35:04 +0900

    Bump RDoc version to 6.17.0 (#15439)

  Notes:
    Merged-By: st0012 <stan001212@gmail.com>

commit db6071b5216ac58976f8ab8181ff6eab02dfa8be
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-07 12:31:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-07 23:20:25 +0900

    [ruby/pathname] Raise the previous message

    Fix ruby/pathname#75.

    https://github.com/ruby/pathname/commit/5ba967b274

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15437

commit a8a188e1fc8568185c2ca460b5a2e800e9cac4bd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-07 12:29:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-07 23:20:24 +0900

    [ruby/pathname] Add more tests for `Pathname#initialize`

    https://github.com/ruby/pathname/commit/a2edd25bc1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15437

commit 806f2d3533ec5bbf6b4d598b36b1c9de7e786659
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-07 11:34:11 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-07 22:51:22 +0900

    [ruby/pathname] [DOC] Pathname#freeze

    https://github.com/ruby/pathname/commit/4580540a2b

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15437

commit f2b250c150b947c3b2341796b2ce44dd94002055
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-07 00:06:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-07 22:51:22 +0900

    [ruby/pathname] Define private method `same_paths?` for Ractor-safety

    https://github.com/ruby/pathname/commit/d33d18e5e2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15437

commit 4080abecd6f7b2ce6f7e6a6d1801d3d9fcfa9a58
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-07 18:16:02 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-07 21:18:00 +0900

    Ignore distclean failures

    Just clean the directory if it exists and is empty.

commit eafaff9443daebba1f4e1a5b2a217b993f066360
  Author:     Samuel Williams <samuel.williams@shopify.com>
  AuthorDate: 2025-12-07 20:55:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-07 20:55:13 +0900

    Re-introduce support for `io_close` hook. (#15434)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 941e70ab38d01d067b7bbbcdf8553893a9ca8b49
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-06 12:09:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-12-07 17:34:45 +0900

    Sync doc/stringio in sync_default_gems.rb

commit 68eab91b147dee98873b54e97296a36301191d72
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-07 13:44:19 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2025-12-07 13:44:19 +0900

    Allow to sync pathname manually

    Still development of the gem continues, sync as possible manually.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15436

commit fb80f84fc7aac043db63e27948a54ce94fcf0da3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-03 11:43:29 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-07 10:59:50 +0900

    [DOC] Fix formatting in docs for String#[]=

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15381

commit 33837abb81510d25088375bbfd74baba16ea2ed1
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 08:21:38 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 08:22:04 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#pos=
    (https://github.com/ruby/stringio/pull/194)

    https://github.com/ruby/stringio/commit/3cef1e0e5f

commit 82577ac09005cf949e125ebe9bb4561002768e5a
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 08:21:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 08:22:00 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#pos
    (https://github.com/ruby/stringio/pull/193)

    https://github.com/ruby/stringio/commit/90728bbbca

commit c9fe3cba39fda954e532424c2c082da915320da9
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 08:21:14 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 08:21:38 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#lineno=
    (https://github.com/ruby/stringio/pull/192)

    https://github.com/ruby/stringio/commit/8b1ee03cbe

commit f298beb2d973debe7ac080aecd28df543678adcf
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2025-12-07 08:20:50 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 08:21:17 +0900

    [ruby/stringio] [DOC] Tweaks for StringIO#lineno
    (https://github.com/ruby/stringio/pull/191)

    https://github.com/ruby/stringio/commit/f2a2a5a99e

commit 588347a088625b5c16eedbc5f3a7a1189a427e25
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-07 01:47:34 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2025-12-07 03:08:24 +0900

    Fix id2ref for multi-Ractor

    The id2ref table needs to be under a VM lock to ensure there are no race
    conditions. The following script crashes:

        o = Object.new

        ObjectSpace._id2ref(o.object_id)

        10.times.map do
          Ractor.new do
            10_000.times do
              a = Object.new
              a.object_id
            end
          end
        end.map(&:value)

    With:

        [BUG] Object ID seen, but not in _id2ref table: object_id=2800 object=T_OBJECT
        ruby 4.0.0dev (2025-12-06T15:15:43Z ractor-id2ref-fix e7f9abdc91) +PRISM [x86_64-linux]

        -- Control frame information -----------------------------------------------
        c:0001 p:---- s:0003 e:000002 l:y b:---- DUMMY  [FINISH]

        -- Threading information ---------------------------------------------------
        Total ractor count: 5
        Ruby thread count for this ractor: 1

        -- C level backtrace information -------------------------------------------
        miniruby(rb_print_backtrace+0x14) [0x6047d09b2dff] vm_dump.c:1105
        miniruby(rb_vm_bugreport) vm_dump.c:1450
        miniruby(rb_bug_without_die_internal+0x5f) [0x6047d066bf57] error.c:1098
        miniruby(rb_bug) error.c:1116
        miniruby(rb_gc_get_ractor_newobj_cache+0x0) [0x6047d066c8dd] gc.c:2052
        miniruby(gc_sweep_plane+0xad) [0x6047d079276d] gc/default/default.c:3513
        miniruby(gc_sweep_page) gc/default/default.c:3605
        miniruby(gc_sweep_step) gc/default/default.c:3886
        miniruby(gc_sweep+0x1ba) [0x6047d0794cfa] gc/default/default.c:4154
        miniruby(gc_start+0xbf2) [0x6047d0796742] gc/default/default.c:6519
        miniruby(heap_prepare+0xcc) [0x6047d079748c] gc/default/default.c:2090
        miniruby(heap_next_free_page) gc/default/default.c:2305
        miniruby(newobj_cache_miss) gc/default/default.c:2412
        miniruby(newobj_alloc+0xd) [0x6047d0798ff5] gc/default/default.c:2436
        miniruby(rb_gc_impl_new_obj) gc/default/default.c:2515
        miniruby(newobj_of) gc.c:996
        miniruby(rb_wb_protected_newobj_of) gc.c:1046
        miniruby(str_alloc_embed+0x28) [0x6047d08fda18] string.c:1019
        miniruby(str_enc_new) string.c:1069
        miniruby(prep_io+0x5) [0x6047d07cda14] io.c:9305
        miniruby(prep_stdio) io.c:9347
        miniruby(rb_io_prep_stdin) io.c:9365
        miniruby(thread_start_func_2+0x77c) [0x6047d093a55c] thread.c:679
        miniruby(thread_sched_lock_+0x0) [0x6047d093aacd] thread_pthread.c:2241
        miniruby(co_start) thread_pthread_mn.c:469

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15433

commit 87bc106b8790d5beaccc46555538424fccb1f50f
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2025-12-07 02:37:40 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 02:49:13 +0900

    [ruby/stringio] [DOC] Change link to on-page

    https://github.com/ruby/stringio/commit/a7c118d786

commit 47c0dae188162798c50fdb2580d852ceec89f2ec
  Author:     Theo Buehler <tb@openbsd.org>
  AuthorDate: 2025-12-07 01:58:56 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 02:26:32 +0900

    [ruby/openssl] asn1integer_to_num: don't cast away const

    ASN1_ENUMERATED_to_BN() has been const-correct for a long time in all
    supported libcrytos, so we can remove this workaround.

    https://github.com/ruby/openssl/commit/d0f36a7c65

commit 1f0d41aa4d1a3b36e9640e5e8e64c030c71ed613
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-12-07 02:07:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2025-12-07 02:13:32 +0900

    [ruby/date] Call rb_gc_register_mark_object after object allocation

    It's possible that both half_days_in_day and day_in_nanoseconds are Ruby
    objects, which means that creating day_in_nanoseconds may trigger GC.
    Since half_days_in_day is not registered as a mark object until after
    day_in_nanoseconds is allocated, the GC may reclaim half_days_in_day.

    We can see this crash:

        ruby(rb_print_backtrace+0xb) [0x63a373c0] vm_dump.c:1105
        ruby(rb_vm_bugreport) vm_dump.c:1450
        ruby(rb_assert_failure_detail+0xdb) [0x6371d3a2] error.c:1216
        ruby(RB_FL_TEST_RAW+0x0) [0x6371d3d5] error.c:1192
        ruby(rb_assert_failure) (null):0
        ruby(rb_gc_impl_writebarrier+0xb4) [0x636f01e4] gc/default/default.c:6103
        ruby(pin_array_list_append+0x72) [0x638f9787] include/ruby/internal/gc.h:788
        ruby(rb_vm_register_global_object) vm.c:4713
        ruby(rb_gc_register_mark_object+0x3a) [0x6374144a] gc.c:3449
        .ext/i686-linux-gnu/date_core.so(Init_date_core+0x204) [0xdbec86c4] ext/date/date_core.c:9511
        .ext/i686-linux-gnu/date_core.so(Init_date_core) (null):0
        ruby(dln_load_and_init+0x71) [0x6392c541] dln.c:521
        ruby(dln_load_feature+0xd2) [0x6392c7d2] dln.c:566
        ruby(load_ext+0xc3) [0x637931b3] load.c:1210
        ruby(rb_vm_pop_frame+0x0) [0x638f80cd] vm.c:3120
        ruby(rb_vm_call_cfunc_in_box) vm.c:3122
        ruby(rb_long2num_inline+0x0) [0x637956f8] load.c:1353
        ruby(require_internal) load.c:1354
        ruby(rb_require_string_internal+0x60) [0x63795fa1] load.c:1457
        ruby(rb_require_string) load.c:1443

